"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.source = void 0;
const source = "var pwExport;\n/******/ (() => { // webpackBootstrap\n/******/ \t\"use strict\";\n/******/ \tvar __webpack_modules__ = ({\n\n/***/ \"./packages/playwright-core/src/server/common/componentUtils.ts\":\n/*!**********************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/common/componentUtils.ts ***!\n  \\**********************************************************************/\n/***/ ((__unused_webpack_module, exports) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.checkComponentAttribute = checkComponentAttribute;\nexports.parseComponentSelector = parseComponentSelector;\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nfunction checkComponentAttribute(obj, attr) {\n  for (const token of attr.jsonPath) {\n    if (obj !== undefined && obj !== null) obj = obj[token];\n  }\n\n  const objValue = typeof obj === 'string' && !attr.caseSensetive ? obj.toUpperCase() : obj;\n  const attrValue = typeof attr.value === 'string' && !attr.caseSensetive ? attr.value.toUpperCase() : attr.value;\n  if (attr.op === '<truthy>') return !!objValue;\n  if (attr.op === '=') return objValue === attrValue;\n  if (typeof objValue !== 'string' || typeof attrValue !== 'string') return false;\n  if (attr.op === '*=') return objValue.includes(attrValue);\n  if (attr.op === '^=') return objValue.startsWith(attrValue);\n  if (attr.op === '$=') return objValue.endsWith(attrValue);\n  if (attr.op === '|=') return objValue === attrValue || objValue.startsWith(attrValue + '-');\n  if (attr.op === '~=') return objValue.split(' ').includes(attrValue);\n  return false;\n}\n\nfunction parseComponentSelector(selector) {\n  let wp = 0;\n  let EOL = selector.length === 0;\n\n  const next = () => selector[wp] || '';\n\n  const eat1 = () => {\n    const result = next();\n    ++wp;\n    EOL = wp >= selector.length;\n    return result;\n  };\n\n  const syntaxError = stage => {\n    if (EOL) throw new Error(`Unexpected end of selector while parsing selector \\`${selector}\\``);\n    throw new Error(`Error while parsing selector \\`${selector}\\` - unexpected symbol \"${next()}\" at position ${wp}` + (stage ? ' during ' + stage : ''));\n  };\n\n  function skipSpaces() {\n    while (!EOL && /\\s/.test(next())) eat1();\n  }\n\n  function readIdentifier() {\n    let result = '';\n    skipSpaces();\n\n    while (!EOL && /[-$0-9A-Z_]/i.test(next())) result += eat1();\n\n    return result;\n  }\n\n  function readQuotedString(quote) {\n    let result = eat1();\n    if (result !== quote) syntaxError('parsing quoted string');\n\n    while (!EOL && next() !== quote) {\n      if (next() === '\\\\') eat1();\n      result += eat1();\n    }\n\n    if (next() !== quote) syntaxError('parsing quoted string');\n    result += eat1();\n    return result;\n  }\n\n  function readAttributeToken() {\n    let token = '';\n    skipSpaces();\n    if (next() === `'` || next() === `\"`) token = readQuotedString(next()).slice(1, -1);else token = readIdentifier();\n    if (!token) syntaxError('parsing property path');\n    return token;\n  }\n\n  function readOperator() {\n    skipSpaces();\n    let op = '';\n    if (!EOL) op += eat1();\n    if (!EOL && op !== '=') op += eat1();\n    if (!['=', '*=', '^=', '$=', '|=', '~='].includes(op)) syntaxError('parsing operator');\n    return op;\n  }\n\n  function readAttribute() {\n    // skip leading [\n    eat1(); // read attribute name:\n    // foo.bar\n    // 'foo'  . \"ba zz\"\n\n    const jsonPath = [];\n    jsonPath.push(readAttributeToken());\n    skipSpaces();\n\n    while (next() === '.') {\n      eat1();\n      jsonPath.push(readAttributeToken());\n      skipSpaces();\n    } // check property is truthy: [enabled]\n\n\n    if (next() === ']') {\n      eat1();\n      return {\n        jsonPath,\n        op: '<truthy>',\n        value: null,\n        caseSensetive: false\n      };\n    }\n\n    const operator = readOperator();\n    let value = undefined;\n    let caseSensetive = true;\n    skipSpaces();\n\n    if (next() === `'` || next() === `\"`) {\n      value = readQuotedString(next()).slice(1, -1);\n      skipSpaces();\n\n      if (next() === 'i' || next() === 'I') {\n        caseSensetive = false;\n        eat1();\n      } else if (next() === 's' || next() === 'S') {\n        caseSensetive = true;\n        eat1();\n      }\n    } else {\n      value = '';\n\n      while (!EOL && !/\\s/.test(next()) && next() !== ']') value += eat1();\n\n      if (value === 'true') {\n        value = true;\n      } else if (value === 'false') {\n        value = false;\n      } else {\n        value = +value;\n        if (isNaN(value)) syntaxError('parsing attribute value');\n      }\n    }\n\n    skipSpaces();\n    if (next() !== ']') syntaxError('parsing attribute value');\n    eat1();\n    if (operator !== '=' && typeof value !== 'string') throw new Error(`Error while parsing selector \\`${selector}\\` - cannot use ${operator} in attribute with non-string matching value - ${value}`);\n    return {\n      jsonPath,\n      op: operator,\n      value,\n      caseSensetive\n    };\n  }\n\n  const result = {\n    name: '',\n    attributes: []\n  };\n  result.name = readIdentifier();\n  skipSpaces();\n\n  while (next() === '[') {\n    result.attributes.push(readAttribute());\n    skipSpaces();\n  }\n\n  if (!EOL) syntaxError(undefined);\n  if (!result.name && !result.attributes.length) throw new Error(`Error while parsing selector \\`${selector}\\` - selector cannot be empty`);\n  return result;\n}\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/common/cssParser.ts\":\n/*!*****************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/common/cssParser.ts ***!\n  \\*****************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.parseCSS = parseCSS;\nexports.serializeSelector = serializeSelector;\n\nvar css = _interopRequireWildcard(__webpack_require__(/*! ./cssTokenizer */ \"./packages/playwright-core/src/server/common/cssTokenizer.js\"));\n\nfunction _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== \"function\") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }\n\nfunction _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== \"object\" && typeof obj !== \"function\") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== \"default\" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nfunction parseCSS(selector, customNames) {\n  let tokens;\n\n  try {\n    tokens = css.tokenize(selector);\n    if (!(tokens[tokens.length - 1] instanceof css.EOFToken)) tokens.push(new css.EOFToken());\n  } catch (e) {\n    const newMessage = e.message + ` while parsing selector \"${selector}\"`;\n    const index = (e.stack || '').indexOf(e.message);\n    if (index !== -1) e.stack = e.stack.substring(0, index) + newMessage + e.stack.substring(index + e.message.length);\n    e.message = newMessage;\n    throw e;\n  }\n\n  const unsupportedToken = tokens.find(token => {\n    return token instanceof css.AtKeywordToken || token instanceof css.BadStringToken || token instanceof css.BadURLToken || token instanceof css.ColumnToken || token instanceof css.CDOToken || token instanceof css.CDCToken || token instanceof css.SemicolonToken || token instanceof css.OpenCurlyToken || token instanceof css.CloseCurlyToken || token instanceof css.URLToken || token instanceof css.PercentageToken;\n  });\n  if (unsupportedToken) throw new Error(`Unsupported token \"${unsupportedToken.toSource()}\" while parsing selector \"${selector}\"`);\n  let pos = 0;\n  const names = new Set();\n\n  function unexpected() {\n    return new Error(`Unexpected token \"${tokens[pos].toSource()}\" while parsing selector \"${selector}\"`);\n  }\n\n  function skipWhitespace() {\n    while (tokens[pos] instanceof css.WhitespaceToken) pos++;\n  }\n\n  function isIdent(p = pos) {\n    return tokens[p] instanceof css.IdentToken;\n  }\n\n  function isString(p = pos) {\n    return tokens[p] instanceof css.StringToken;\n  }\n\n  function isNumber(p = pos) {\n    return tokens[p] instanceof css.NumberToken;\n  }\n\n  function isComma(p = pos) {\n    return tokens[p] instanceof css.CommaToken;\n  }\n\n  function isCloseParen(p = pos) {\n    return tokens[p] instanceof css.CloseParenToken;\n  }\n\n  function isStar(p = pos) {\n    return tokens[p] instanceof css.DelimToken && tokens[p].value === '*';\n  }\n\n  function isEOF(p = pos) {\n    return tokens[p] instanceof css.EOFToken;\n  }\n\n  function isClauseCombinator(p = pos) {\n    return tokens[p] instanceof css.DelimToken && ['>', '+', '~'].includes(tokens[p].value);\n  }\n\n  function isSelectorClauseEnd(p = pos) {\n    return isComma(p) || isCloseParen(p) || isEOF(p) || isClauseCombinator(p) || tokens[p] instanceof css.WhitespaceToken;\n  }\n\n  function consumeFunctionArguments() {\n    const result = [consumeArgument()];\n\n    while (true) {\n      skipWhitespace();\n      if (!isComma()) break;\n      pos++;\n      result.push(consumeArgument());\n    }\n\n    return result;\n  }\n\n  function consumeArgument() {\n    skipWhitespace();\n    if (isNumber()) return tokens[pos++].value;\n    if (isString()) return tokens[pos++].value;\n    return consumeComplexSelector();\n  }\n\n  function consumeComplexSelector() {\n    const result = {\n      simples: []\n    };\n    skipWhitespace();\n\n    if (isClauseCombinator()) {\n      // Put implicit \":scope\" at the start. https://drafts.csswg.org/selectors-4/#absolutize\n      result.simples.push({\n        selector: {\n          functions: [{\n            name: 'scope',\n            args: []\n          }]\n        },\n        combinator: ''\n      });\n    } else {\n      result.simples.push({\n        selector: consumeSimpleSelector(),\n        combinator: ''\n      });\n    }\n\n    while (true) {\n      skipWhitespace();\n\n      if (isClauseCombinator()) {\n        result.simples[result.simples.length - 1].combinator = tokens[pos++].value;\n        skipWhitespace();\n      } else if (isSelectorClauseEnd()) {\n        break;\n      }\n\n      result.simples.push({\n        combinator: '',\n        selector: consumeSimpleSelector()\n      });\n    }\n\n    return result;\n  }\n\n  function consumeSimpleSelector() {\n    let rawCSSString = '';\n    const functions = [];\n\n    while (!isSelectorClauseEnd()) {\n      if (isIdent() || isStar()) {\n        rawCSSString += tokens[pos++].toSource();\n      } else if (tokens[pos] instanceof css.HashToken) {\n        rawCSSString += tokens[pos++].toSource();\n      } else if (tokens[pos] instanceof css.DelimToken && tokens[pos].value === '.') {\n        pos++;\n        if (isIdent()) rawCSSString += '.' + tokens[pos++].toSource();else throw unexpected();\n      } else if (tokens[pos] instanceof css.ColonToken) {\n        pos++;\n\n        if (isIdent()) {\n          if (!customNames.has(tokens[pos].value.toLowerCase())) {\n            rawCSSString += ':' + tokens[pos++].toSource();\n          } else {\n            const name = tokens[pos++].value.toLowerCase();\n            functions.push({\n              name,\n              args: []\n            });\n            names.add(name);\n          }\n        } else if (tokens[pos] instanceof css.FunctionToken) {\n          const name = tokens[pos++].value.toLowerCase();\n\n          if (!customNames.has(name)) {\n            rawCSSString += `:${name}(${consumeBuiltinFunctionArguments()})`;\n          } else {\n            functions.push({\n              name,\n              args: consumeFunctionArguments()\n            });\n            names.add(name);\n          }\n\n          skipWhitespace();\n          if (!isCloseParen()) throw unexpected();\n          pos++;\n        } else {\n          throw unexpected();\n        }\n      } else if (tokens[pos] instanceof css.OpenSquareToken) {\n        rawCSSString += '[';\n        pos++;\n\n        while (!(tokens[pos] instanceof css.CloseSquareToken) && !isEOF()) rawCSSString += tokens[pos++].toSource();\n\n        if (!(tokens[pos] instanceof css.CloseSquareToken)) throw unexpected();\n        rawCSSString += ']';\n        pos++;\n      } else {\n        throw unexpected();\n      }\n    }\n\n    if (!rawCSSString && !functions.length) throw unexpected();\n    return {\n      css: rawCSSString || undefined,\n      functions\n    };\n  }\n\n  function consumeBuiltinFunctionArguments() {\n    let s = '';\n\n    while (!isCloseParen() && !isEOF()) s += tokens[pos++].toSource();\n\n    return s;\n  }\n\n  const result = consumeFunctionArguments();\n  if (!isEOF()) throw new Error(`Error while parsing selector \"${selector}\"`);\n  if (result.some(arg => typeof arg !== 'object' || !('simples' in arg))) throw new Error(`Error while parsing selector \"${selector}\"`);\n  return {\n    selector: result,\n    names: Array.from(names)\n  };\n}\n\nfunction serializeSelector(args) {\n  return args.map(arg => {\n    if (typeof arg === 'string') return `\"${arg}\"`;\n    if (typeof arg === 'number') return String(arg);\n    return arg.simples.map(({\n      selector,\n      combinator\n    }) => {\n      let s = selector.css || '';\n      s = s + selector.functions.map(func => `:${func.name}(${serializeSelector(func.args)})`).join('');\n      if (combinator) s += ' ' + combinator;\n      return s;\n    }).join(' ');\n  }).join(', ');\n}\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/common/cssTokenizer.js\":\n/*!********************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/common/cssTokenizer.js ***!\n  \\********************************************************************/\n/***/ ((module, exports) => {\n\nvar __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;\n\n/*\n * Original at https://github.com/tabatkins/parse-css\n * licensed under http://creativecommons.org/publicdomain/zero/1.0/\n *\n * Modifications copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\n// Changes from https://github.com/tabatkins/parse-css\n//   - Tabs are replaced with two spaces.\n//   - Everything not related to tokenizing - below the first exports block - is removed.\n// @ts-nocheck\n(function (root, factory) {\n  // Universal Module Definition (UMD) to support AMD, CommonJS/Node.js,\n  // Rhino, and plain browser loading.\n  if (true) {\n    !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory),\n\t\t__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?\n\t\t(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),\n\t\t__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));\n  } else {}\n})(void 0, function (exports) {\n  var between = function (num, first, last) {\n    return num >= first && num <= last;\n  };\n\n  function digit(code) {\n    return between(code, 0x30, 0x39);\n  }\n\n  function hexdigit(code) {\n    return digit(code) || between(code, 0x41, 0x46) || between(code, 0x61, 0x66);\n  }\n\n  function uppercaseletter(code) {\n    return between(code, 0x41, 0x5a);\n  }\n\n  function lowercaseletter(code) {\n    return between(code, 0x61, 0x7a);\n  }\n\n  function letter(code) {\n    return uppercaseletter(code) || lowercaseletter(code);\n  }\n\n  function nonascii(code) {\n    return code >= 0x80;\n  }\n\n  function namestartchar(code) {\n    return letter(code) || nonascii(code) || code == 0x5f;\n  }\n\n  function namechar(code) {\n    return namestartchar(code) || digit(code) || code == 0x2d;\n  }\n\n  function nonprintable(code) {\n    return between(code, 0, 8) || code == 0xb || between(code, 0xe, 0x1f) || code == 0x7f;\n  }\n\n  function newline(code) {\n    return code == 0xa;\n  }\n\n  function whitespace(code) {\n    return newline(code) || code == 9 || code == 0x20;\n  }\n\n  function badescape(code) {\n    return newline(code) || isNaN(code);\n  }\n\n  var maximumallowedcodepoint = 0x10ffff;\n\n  var InvalidCharacterError = function (message) {\n    this.message = message;\n  };\n\n  InvalidCharacterError.prototype = new Error();\n  InvalidCharacterError.prototype.name = 'InvalidCharacterError';\n\n  function preprocess(str) {\n    // Turn a string into an array of code points,\n    // following the preprocessing cleanup rules.\n    var codepoints = [];\n\n    for (var i = 0; i < str.length; i++) {\n      var code = str.charCodeAt(i);\n\n      if (code == 0xd && str.charCodeAt(i + 1) == 0xa) {\n        code = 0xa;\n        i++;\n      }\n\n      if (code == 0xd || code == 0xc) code = 0xa;\n      if (code == 0x0) code = 0xfffd;\n\n      if (between(code, 0xd800, 0xdbff) && between(str.charCodeAt(i + 1), 0xdc00, 0xdfff)) {\n        // Decode a surrogate pair into an astral codepoint.\n        var lead = code - 0xd800;\n        var trail = str.charCodeAt(i + 1) - 0xdc00;\n        code = Math.pow(2, 16) + lead * Math.pow(2, 10) + trail;\n        i++;\n      }\n\n      codepoints.push(code);\n    }\n\n    return codepoints;\n  }\n\n  function stringFromCode(code) {\n    if (code <= 0xffff) return String.fromCharCode(code); // Otherwise, encode astral char as surrogate pair.\n\n    code -= Math.pow(2, 16);\n    var lead = Math.floor(code / Math.pow(2, 10)) + 0xd800;\n    var trail = code % Math.pow(2, 10) + 0xdc00;\n    return String.fromCharCode(lead) + String.fromCharCode(trail);\n  }\n\n  function tokenize(str) {\n    str = preprocess(str);\n    var i = -1;\n    var tokens = [];\n    var code; // Line number information.\n\n    var line = 0;\n    var column = 0; // The only use of lastLineLength is in reconsume().\n\n    var lastLineLength = 0;\n\n    var incrLineno = function () {\n      line += 1;\n      lastLineLength = column;\n      column = 0;\n    };\n\n    var locStart = {\n      line: line,\n      column: column\n    };\n\n    var codepoint = function (i) {\n      if (i >= str.length) {\n        return -1;\n      }\n\n      return str[i];\n    };\n\n    var next = function (num) {\n      if (num === undefined) num = 1;\n      if (num > 3) throw \"Spec Error: no more than three codepoints of lookahead.\";\n      return codepoint(i + num);\n    };\n\n    var consume = function (num) {\n      if (num === undefined) num = 1;\n      i += num;\n      code = codepoint(i);\n      if (newline(code)) incrLineno();else column += num; //console.log('Consume '+i+' '+String.fromCharCode(code) + ' 0x' + code.toString(16));\n\n      return true;\n    };\n\n    var reconsume = function () {\n      i -= 1;\n\n      if (newline(code)) {\n        line -= 1;\n        column = lastLineLength;\n      } else {\n        column -= 1;\n      }\n\n      locStart.line = line;\n      locStart.column = column;\n      return true;\n    };\n\n    var eof = function (codepoint) {\n      if (codepoint === undefined) codepoint = code;\n      return codepoint == -1;\n    };\n\n    var donothing = function () {};\n\n    var parseerror = function () {\n      console.log(\"Parse error at index \" + i + \", processing codepoint 0x\" + code.toString(16) + \".\");\n      return true;\n    };\n\n    var consumeAToken = function () {\n      consumeComments();\n      consume();\n\n      if (whitespace(code)) {\n        while (whitespace(next())) consume();\n\n        return new WhitespaceToken();\n      } else if (code == 0x22) return consumeAStringToken();else if (code == 0x23) {\n        if (namechar(next()) || areAValidEscape(next(1), next(2))) {\n          var token = new HashToken();\n          if (wouldStartAnIdentifier(next(1), next(2), next(3))) token.type = \"id\";\n          token.value = consumeAName();\n          return token;\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x24) {\n        if (next() == 0x3d) {\n          consume();\n          return new SuffixMatchToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x27) return consumeAStringToken();else if (code == 0x28) return new OpenParenToken();else if (code == 0x29) return new CloseParenToken();else if (code == 0x2a) {\n        if (next() == 0x3d) {\n          consume();\n          return new SubstringMatchToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x2b) {\n        if (startsWithANumber()) {\n          reconsume();\n          return consumeANumericToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x2c) return new CommaToken();else if (code == 0x2d) {\n        if (startsWithANumber()) {\n          reconsume();\n          return consumeANumericToken();\n        } else if (next(1) == 0x2d && next(2) == 0x3e) {\n          consume(2);\n          return new CDCToken();\n        } else if (startsWithAnIdentifier()) {\n          reconsume();\n          return consumeAnIdentlikeToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x2e) {\n        if (startsWithANumber()) {\n          reconsume();\n          return consumeANumericToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x3a) return new ColonToken();else if (code == 0x3b) return new SemicolonToken();else if (code == 0x3c) {\n        if (next(1) == 0x21 && next(2) == 0x2d && next(3) == 0x2d) {\n          consume(3);\n          return new CDOToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x40) {\n        if (wouldStartAnIdentifier(next(1), next(2), next(3))) {\n          return new AtKeywordToken(consumeAName());\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x5b) return new OpenSquareToken();else if (code == 0x5c) {\n        if (startsWithAValidEscape()) {\n          reconsume();\n          return consumeAnIdentlikeToken();\n        } else {\n          parseerror();\n          return new DelimToken(code);\n        }\n      } else if (code == 0x5d) return new CloseSquareToken();else if (code == 0x5e) {\n        if (next() == 0x3d) {\n          consume();\n          return new PrefixMatchToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x7b) return new OpenCurlyToken();else if (code == 0x7c) {\n        if (next() == 0x3d) {\n          consume();\n          return new DashMatchToken();\n        } else if (next() == 0x7c) {\n          consume();\n          return new ColumnToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (code == 0x7d) return new CloseCurlyToken();else if (code == 0x7e) {\n        if (next() == 0x3d) {\n          consume();\n          return new IncludeMatchToken();\n        } else {\n          return new DelimToken(code);\n        }\n      } else if (digit(code)) {\n        reconsume();\n        return consumeANumericToken();\n      } else if (namestartchar(code)) {\n        reconsume();\n        return consumeAnIdentlikeToken();\n      } else if (eof()) return new EOFToken();else return new DelimToken(code);\n    };\n\n    var consumeComments = function () {\n      while (next(1) == 0x2f && next(2) == 0x2a) {\n        consume(2);\n\n        while (true) {\n          consume();\n\n          if (code == 0x2a && next() == 0x2f) {\n            consume();\n            break;\n          } else if (eof()) {\n            parseerror();\n            return;\n          }\n        }\n      }\n    };\n\n    var consumeANumericToken = function () {\n      var num = consumeANumber();\n\n      if (wouldStartAnIdentifier(next(1), next(2), next(3))) {\n        var token = new DimensionToken();\n        token.value = num.value;\n        token.repr = num.repr;\n        token.type = num.type;\n        token.unit = consumeAName();\n        return token;\n      } else if (next() == 0x25) {\n        consume();\n        var token = new PercentageToken();\n        token.value = num.value;\n        token.repr = num.repr;\n        return token;\n      } else {\n        var token = new NumberToken();\n        token.value = num.value;\n        token.repr = num.repr;\n        token.type = num.type;\n        return token;\n      }\n    };\n\n    var consumeAnIdentlikeToken = function () {\n      var str = consumeAName();\n\n      if (str.toLowerCase() == \"url\" && next() == 0x28) {\n        consume();\n\n        while (whitespace(next(1)) && whitespace(next(2))) consume();\n\n        if (next() == 0x22 || next() == 0x27) {\n          return new FunctionToken(str);\n        } else if (whitespace(next()) && (next(2) == 0x22 || next(2) == 0x27)) {\n          return new FunctionToken(str);\n        } else {\n          return consumeAURLToken();\n        }\n      } else if (next() == 0x28) {\n        consume();\n        return new FunctionToken(str);\n      } else {\n        return new IdentToken(str);\n      }\n    };\n\n    var consumeAStringToken = function (endingCodePoint) {\n      if (endingCodePoint === undefined) endingCodePoint = code;\n      var string = \"\";\n\n      while (consume()) {\n        if (code == endingCodePoint || eof()) {\n          return new StringToken(string);\n        } else if (newline(code)) {\n          parseerror();\n          reconsume();\n          return new BadStringToken();\n        } else if (code == 0x5c) {\n          if (eof(next())) {\n            donothing();\n          } else if (newline(next())) {\n            consume();\n          } else {\n            string += stringFromCode(consumeEscape());\n          }\n        } else {\n          string += stringFromCode(code);\n        }\n      }\n    };\n\n    var consumeAURLToken = function () {\n      var token = new URLToken(\"\");\n\n      while (whitespace(next())) consume();\n\n      if (eof(next())) return token;\n\n      while (consume()) {\n        if (code == 0x29 || eof()) {\n          return token;\n        } else if (whitespace(code)) {\n          while (whitespace(next())) consume();\n\n          if (next() == 0x29 || eof(next())) {\n            consume();\n            return token;\n          } else {\n            consumeTheRemnantsOfABadURL();\n            return new BadURLToken();\n          }\n        } else if (code == 0x22 || code == 0x27 || code == 0x28 || nonprintable(code)) {\n          parseerror();\n          consumeTheRemnantsOfABadURL();\n          return new BadURLToken();\n        } else if (code == 0x5c) {\n          if (startsWithAValidEscape()) {\n            token.value += stringFromCode(consumeEscape());\n          } else {\n            parseerror();\n            consumeTheRemnantsOfABadURL();\n            return new BadURLToken();\n          }\n        } else {\n          token.value += stringFromCode(code);\n        }\n      }\n    };\n\n    var consumeEscape = function () {\n      // Assume the the current character is the \\\n      // and the next code point is not a newline.\n      consume();\n\n      if (hexdigit(code)) {\n        // Consume 1-6 hex digits\n        var digits = [code];\n\n        for (var total = 0; total < 5; total++) {\n          if (hexdigit(next())) {\n            consume();\n            digits.push(code);\n          } else {\n            break;\n          }\n        }\n\n        if (whitespace(next())) consume();\n        var value = parseInt(digits.map(function (x) {\n          return String.fromCharCode(x);\n        }).join(''), 16);\n        if (value > maximumallowedcodepoint) value = 0xfffd;\n        return value;\n      } else if (eof()) {\n        return 0xfffd;\n      } else {\n        return code;\n      }\n    };\n\n    var areAValidEscape = function (c1, c2) {\n      if (c1 != 0x5c) return false;\n      if (newline(c2)) return false;\n      return true;\n    };\n\n    var startsWithAValidEscape = function () {\n      return areAValidEscape(code, next());\n    };\n\n    var wouldStartAnIdentifier = function (c1, c2, c3) {\n      if (c1 == 0x2d) {\n        return namestartchar(c2) || c2 == 0x2d || areAValidEscape(c2, c3);\n      } else if (namestartchar(c1)) {\n        return true;\n      } else if (c1 == 0x5c) {\n        return areAValidEscape(c1, c2);\n      } else {\n        return false;\n      }\n    };\n\n    var startsWithAnIdentifier = function () {\n      return wouldStartAnIdentifier(code, next(1), next(2));\n    };\n\n    var wouldStartANumber = function (c1, c2, c3) {\n      if (c1 == 0x2b || c1 == 0x2d) {\n        if (digit(c2)) return true;\n        if (c2 == 0x2e && digit(c3)) return true;\n        return false;\n      } else if (c1 == 0x2e) {\n        if (digit(c2)) return true;\n        return false;\n      } else if (digit(c1)) {\n        return true;\n      } else {\n        return false;\n      }\n    };\n\n    var startsWithANumber = function () {\n      return wouldStartANumber(code, next(1), next(2));\n    };\n\n    var consumeAName = function () {\n      var result = \"\";\n\n      while (consume()) {\n        if (namechar(code)) {\n          result += stringFromCode(code);\n        } else if (startsWithAValidEscape()) {\n          result += stringFromCode(consumeEscape());\n        } else {\n          reconsume();\n          return result;\n        }\n      }\n    };\n\n    var consumeANumber = function () {\n      var repr = [];\n      var type = \"integer\";\n\n      if (next() == 0x2b || next() == 0x2d) {\n        consume();\n        repr += stringFromCode(code);\n      }\n\n      while (digit(next())) {\n        consume();\n        repr += stringFromCode(code);\n      }\n\n      if (next(1) == 0x2e && digit(next(2))) {\n        consume();\n        repr += stringFromCode(code);\n        consume();\n        repr += stringFromCode(code);\n        type = \"number\";\n\n        while (digit(next())) {\n          consume();\n          repr += stringFromCode(code);\n        }\n      }\n\n      var c1 = next(1),\n          c2 = next(2),\n          c3 = next(3);\n\n      if ((c1 == 0x45 || c1 == 0x65) && digit(c2)) {\n        consume();\n        repr += stringFromCode(code);\n        consume();\n        repr += stringFromCode(code);\n        type = \"number\";\n\n        while (digit(next())) {\n          consume();\n          repr += stringFromCode(code);\n        }\n      } else if ((c1 == 0x45 || c1 == 0x65) && (c2 == 0x2b || c2 == 0x2d) && digit(c3)) {\n        consume();\n        repr += stringFromCode(code);\n        consume();\n        repr += stringFromCode(code);\n        consume();\n        repr += stringFromCode(code);\n        type = \"number\";\n\n        while (digit(next())) {\n          consume();\n          repr += stringFromCode(code);\n        }\n      }\n\n      var value = convertAStringToANumber(repr);\n      return {\n        type: type,\n        value: value,\n        repr: repr\n      };\n    };\n\n    var convertAStringToANumber = function (string) {\n      // CSS's number rules are identical to JS, afaik.\n      return +string;\n    };\n\n    var consumeTheRemnantsOfABadURL = function () {\n      while (consume()) {\n        if (code == 0x29 || eof()) {\n          return;\n        } else if (startsWithAValidEscape()) {\n          consumeEscape();\n          donothing();\n        } else {\n          donothing();\n        }\n      }\n    };\n\n    var iterationCount = 0;\n\n    while (!eof(next())) {\n      tokens.push(consumeAToken());\n      iterationCount++;\n      if (iterationCount > str.length * 2) return \"I'm infinite-looping!\";\n    }\n\n    return tokens;\n  }\n\n  function CSSParserToken() {\n    throw \"Abstract Base Class\";\n  }\n\n  CSSParserToken.prototype.toJSON = function () {\n    return {\n      token: this.tokenType\n    };\n  };\n\n  CSSParserToken.prototype.toString = function () {\n    return this.tokenType;\n  };\n\n  CSSParserToken.prototype.toSource = function () {\n    return '' + this;\n  };\n\n  function BadStringToken() {\n    return this;\n  }\n\n  BadStringToken.prototype = Object.create(CSSParserToken.prototype);\n  BadStringToken.prototype.tokenType = \"BADSTRING\";\n\n  function BadURLToken() {\n    return this;\n  }\n\n  BadURLToken.prototype = Object.create(CSSParserToken.prototype);\n  BadURLToken.prototype.tokenType = \"BADURL\";\n\n  function WhitespaceToken() {\n    return this;\n  }\n\n  WhitespaceToken.prototype = Object.create(CSSParserToken.prototype);\n  WhitespaceToken.prototype.tokenType = \"WHITESPACE\";\n\n  WhitespaceToken.prototype.toString = function () {\n    return \"WS\";\n  };\n\n  WhitespaceToken.prototype.toSource = function () {\n    return \" \";\n  };\n\n  function CDOToken() {\n    return this;\n  }\n\n  CDOToken.prototype = Object.create(CSSParserToken.prototype);\n  CDOToken.prototype.tokenType = \"CDO\";\n\n  CDOToken.prototype.toSource = function () {\n    return \"<!--\";\n  };\n\n  function CDCToken() {\n    return this;\n  }\n\n  CDCToken.prototype = Object.create(CSSParserToken.prototype);\n  CDCToken.prototype.tokenType = \"CDC\";\n\n  CDCToken.prototype.toSource = function () {\n    return \"-->\";\n  };\n\n  function ColonToken() {\n    return this;\n  }\n\n  ColonToken.prototype = Object.create(CSSParserToken.prototype);\n  ColonToken.prototype.tokenType = \":\";\n\n  function SemicolonToken() {\n    return this;\n  }\n\n  SemicolonToken.prototype = Object.create(CSSParserToken.prototype);\n  SemicolonToken.prototype.tokenType = \";\";\n\n  function CommaToken() {\n    return this;\n  }\n\n  CommaToken.prototype = Object.create(CSSParserToken.prototype);\n  CommaToken.prototype.tokenType = \",\";\n\n  function GroupingToken() {\n    throw \"Abstract Base Class\";\n  }\n\n  GroupingToken.prototype = Object.create(CSSParserToken.prototype);\n\n  function OpenCurlyToken() {\n    this.value = \"{\";\n    this.mirror = \"}\";\n    return this;\n  }\n\n  OpenCurlyToken.prototype = Object.create(GroupingToken.prototype);\n  OpenCurlyToken.prototype.tokenType = \"{\";\n\n  function CloseCurlyToken() {\n    this.value = \"}\";\n    this.mirror = \"{\";\n    return this;\n  }\n\n  CloseCurlyToken.prototype = Object.create(GroupingToken.prototype);\n  CloseCurlyToken.prototype.tokenType = \"}\";\n\n  function OpenSquareToken() {\n    this.value = \"[\";\n    this.mirror = \"]\";\n    return this;\n  }\n\n  OpenSquareToken.prototype = Object.create(GroupingToken.prototype);\n  OpenSquareToken.prototype.tokenType = \"[\";\n\n  function CloseSquareToken() {\n    this.value = \"]\";\n    this.mirror = \"[\";\n    return this;\n  }\n\n  CloseSquareToken.prototype = Object.create(GroupingToken.prototype);\n  CloseSquareToken.prototype.tokenType = \"]\";\n\n  function OpenParenToken() {\n    this.value = \"(\";\n    this.mirror = \")\";\n    return this;\n  }\n\n  OpenParenToken.prototype = Object.create(GroupingToken.prototype);\n  OpenParenToken.prototype.tokenType = \"(\";\n\n  function CloseParenToken() {\n    this.value = \")\";\n    this.mirror = \"(\";\n    return this;\n  }\n\n  CloseParenToken.prototype = Object.create(GroupingToken.prototype);\n  CloseParenToken.prototype.tokenType = \")\";\n\n  function IncludeMatchToken() {\n    return this;\n  }\n\n  IncludeMatchToken.prototype = Object.create(CSSParserToken.prototype);\n  IncludeMatchToken.prototype.tokenType = \"~=\";\n\n  function DashMatchToken() {\n    return this;\n  }\n\n  DashMatchToken.prototype = Object.create(CSSParserToken.prototype);\n  DashMatchToken.prototype.tokenType = \"|=\";\n\n  function PrefixMatchToken() {\n    return this;\n  }\n\n  PrefixMatchToken.prototype = Object.create(CSSParserToken.prototype);\n  PrefixMatchToken.prototype.tokenType = \"^=\";\n\n  function SuffixMatchToken() {\n    return this;\n  }\n\n  SuffixMatchToken.prototype = Object.create(CSSParserToken.prototype);\n  SuffixMatchToken.prototype.tokenType = \"$=\";\n\n  function SubstringMatchToken() {\n    return this;\n  }\n\n  SubstringMatchToken.prototype = Object.create(CSSParserToken.prototype);\n  SubstringMatchToken.prototype.tokenType = \"*=\";\n\n  function ColumnToken() {\n    return this;\n  }\n\n  ColumnToken.prototype = Object.create(CSSParserToken.prototype);\n  ColumnToken.prototype.tokenType = \"||\";\n\n  function EOFToken() {\n    return this;\n  }\n\n  EOFToken.prototype = Object.create(CSSParserToken.prototype);\n  EOFToken.prototype.tokenType = \"EOF\";\n\n  EOFToken.prototype.toSource = function () {\n    return \"\";\n  };\n\n  function DelimToken(code) {\n    this.value = stringFromCode(code);\n    return this;\n  }\n\n  DelimToken.prototype = Object.create(CSSParserToken.prototype);\n  DelimToken.prototype.tokenType = \"DELIM\";\n\n  DelimToken.prototype.toString = function () {\n    return \"DELIM(\" + this.value + \")\";\n  };\n\n  DelimToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    return json;\n  };\n\n  DelimToken.prototype.toSource = function () {\n    if (this.value == \"\\\\\") return \"\\\\\\n\";else return this.value;\n  };\n\n  function StringValuedToken() {\n    throw \"Abstract Base Class\";\n  }\n\n  StringValuedToken.prototype = Object.create(CSSParserToken.prototype);\n\n  StringValuedToken.prototype.ASCIIMatch = function (str) {\n    return this.value.toLowerCase() == str.toLowerCase();\n  };\n\n  StringValuedToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    return json;\n  };\n\n  function IdentToken(val) {\n    this.value = val;\n  }\n\n  IdentToken.prototype = Object.create(StringValuedToken.prototype);\n  IdentToken.prototype.tokenType = \"IDENT\";\n\n  IdentToken.prototype.toString = function () {\n    return \"IDENT(\" + this.value + \")\";\n  };\n\n  IdentToken.prototype.toSource = function () {\n    return escapeIdent(this.value);\n  };\n\n  function FunctionToken(val) {\n    this.value = val;\n    this.mirror = \")\";\n  }\n\n  FunctionToken.prototype = Object.create(StringValuedToken.prototype);\n  FunctionToken.prototype.tokenType = \"FUNCTION\";\n\n  FunctionToken.prototype.toString = function () {\n    return \"FUNCTION(\" + this.value + \")\";\n  };\n\n  FunctionToken.prototype.toSource = function () {\n    return escapeIdent(this.value) + \"(\";\n  };\n\n  function AtKeywordToken(val) {\n    this.value = val;\n  }\n\n  AtKeywordToken.prototype = Object.create(StringValuedToken.prototype);\n  AtKeywordToken.prototype.tokenType = \"AT-KEYWORD\";\n\n  AtKeywordToken.prototype.toString = function () {\n    return \"AT(\" + this.value + \")\";\n  };\n\n  AtKeywordToken.prototype.toSource = function () {\n    return \"@\" + escapeIdent(this.value);\n  };\n\n  function HashToken(val) {\n    this.value = val;\n    this.type = \"unrestricted\";\n  }\n\n  HashToken.prototype = Object.create(StringValuedToken.prototype);\n  HashToken.prototype.tokenType = \"HASH\";\n\n  HashToken.prototype.toString = function () {\n    return \"HASH(\" + this.value + \")\";\n  };\n\n  HashToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    json.type = this.type;\n    return json;\n  };\n\n  HashToken.prototype.toSource = function () {\n    if (this.type == \"id\") {\n      return \"#\" + escapeIdent(this.value);\n    } else {\n      return \"#\" + escapeHash(this.value);\n    }\n  };\n\n  function StringToken(val) {\n    this.value = val;\n  }\n\n  StringToken.prototype = Object.create(StringValuedToken.prototype);\n  StringToken.prototype.tokenType = \"STRING\";\n\n  StringToken.prototype.toString = function () {\n    return '\"' + escapeString(this.value) + '\"';\n  };\n\n  function URLToken(val) {\n    this.value = val;\n  }\n\n  URLToken.prototype = Object.create(StringValuedToken.prototype);\n  URLToken.prototype.tokenType = \"URL\";\n\n  URLToken.prototype.toString = function () {\n    return \"URL(\" + this.value + \")\";\n  };\n\n  URLToken.prototype.toSource = function () {\n    return 'url(\"' + escapeString(this.value) + '\")';\n  };\n\n  function NumberToken() {\n    this.value = null;\n    this.type = \"integer\";\n    this.repr = \"\";\n  }\n\n  NumberToken.prototype = Object.create(CSSParserToken.prototype);\n  NumberToken.prototype.tokenType = \"NUMBER\";\n\n  NumberToken.prototype.toString = function () {\n    if (this.type == \"integer\") return \"INT(\" + this.value + \")\";\n    return \"NUMBER(\" + this.value + \")\";\n  };\n\n  NumberToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    json.type = this.type;\n    json.repr = this.repr;\n    return json;\n  };\n\n  NumberToken.prototype.toSource = function () {\n    return this.repr;\n  };\n\n  function PercentageToken() {\n    this.value = null;\n    this.repr = \"\";\n  }\n\n  PercentageToken.prototype = Object.create(CSSParserToken.prototype);\n  PercentageToken.prototype.tokenType = \"PERCENTAGE\";\n\n  PercentageToken.prototype.toString = function () {\n    return \"PERCENTAGE(\" + this.value + \")\";\n  };\n\n  PercentageToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    json.repr = this.repr;\n    return json;\n  };\n\n  PercentageToken.prototype.toSource = function () {\n    return this.repr + \"%\";\n  };\n\n  function DimensionToken() {\n    this.value = null;\n    this.type = \"integer\";\n    this.repr = \"\";\n    this.unit = \"\";\n  }\n\n  DimensionToken.prototype = Object.create(CSSParserToken.prototype);\n  DimensionToken.prototype.tokenType = \"DIMENSION\";\n\n  DimensionToken.prototype.toString = function () {\n    return \"DIM(\" + this.value + \",\" + this.unit + \")\";\n  };\n\n  DimensionToken.prototype.toJSON = function () {\n    var json = this.constructor.prototype.constructor.prototype.toJSON.call(this);\n    json.value = this.value;\n    json.type = this.type;\n    json.repr = this.repr;\n    json.unit = this.unit;\n    return json;\n  };\n\n  DimensionToken.prototype.toSource = function () {\n    var source = this.repr;\n    var unit = escapeIdent(this.unit);\n\n    if (unit[0].toLowerCase() == \"e\" && (unit[1] == \"-\" || between(unit.charCodeAt(1), 0x30, 0x39))) {\n      // Unit is ambiguous with scinot\n      // Remove the leading \"e\", replace with escape.\n      unit = \"\\\\65 \" + unit.slice(1, unit.length);\n    }\n\n    return source + unit;\n  };\n\n  function escapeIdent(string) {\n    string = '' + string;\n    var result = '';\n    var firstcode = string.charCodeAt(0);\n\n    for (var i = 0; i < string.length; i++) {\n      var code = string.charCodeAt(i);\n\n      if (code == 0x0) {\n        throw new InvalidCharacterError('Invalid character: the input contains U+0000.');\n      }\n\n      if (between(code, 0x1, 0x1f) || code == 0x7f || i == 0 && between(code, 0x30, 0x39) || i == 1 && between(code, 0x30, 0x39) && firstcode == 0x2d) {\n        result += '\\\\' + code.toString(16) + ' ';\n      } else if (code >= 0x80 || code == 0x2d || code == 0x5f || between(code, 0x30, 0x39) || between(code, 0x41, 0x5a) || between(code, 0x61, 0x7a)) {\n        result += string[i];\n      } else {\n        result += '\\\\' + string[i];\n      }\n    }\n\n    return result;\n  }\n\n  function escapeHash(string) {\n    // Escapes the contents of \"unrestricted\"-type hash tokens.\n    // Won't preserve the ID-ness of \"id\"-type hash tokens;\n    // use escapeIdent() for that.\n    string = '' + string;\n    var result = '';\n    var firstcode = string.charCodeAt(0);\n\n    for (var i = 0; i < string.length; i++) {\n      var code = string.charCodeAt(i);\n\n      if (code == 0x0) {\n        throw new InvalidCharacterError('Invalid character: the input contains U+0000.');\n      }\n\n      if (code >= 0x80 || code == 0x2d || code == 0x5f || between(code, 0x30, 0x39) || between(code, 0x41, 0x5a) || between(code, 0x61, 0x7a)) {\n        result += string[i];\n      } else {\n        result += '\\\\' + code.toString(16) + ' ';\n      }\n    }\n\n    return result;\n  }\n\n  function escapeString(string) {\n    string = '' + string;\n    var result = '';\n\n    for (var i = 0; i < string.length; i++) {\n      var code = string.charCodeAt(i);\n\n      if (code == 0x0) {\n        throw new InvalidCharacterError('Invalid character: the input contains U+0000.');\n      }\n\n      if (between(code, 0x1, 0x1f) || code == 0x7f) {\n        result += '\\\\' + code.toString(16) + ' ';\n      } else if (code == 0x22 || code == 0x5c) {\n        result += '\\\\' + string[i];\n      } else {\n        result += string[i];\n      }\n    }\n\n    return result;\n  } // Exportation.\n\n\n  exports.tokenize = tokenize;\n  exports.IdentToken = IdentToken;\n  exports.FunctionToken = FunctionToken;\n  exports.AtKeywordToken = AtKeywordToken;\n  exports.HashToken = HashToken;\n  exports.StringToken = StringToken;\n  exports.BadStringToken = BadStringToken;\n  exports.URLToken = URLToken;\n  exports.BadURLToken = BadURLToken;\n  exports.DelimToken = DelimToken;\n  exports.NumberToken = NumberToken;\n  exports.PercentageToken = PercentageToken;\n  exports.DimensionToken = DimensionToken;\n  exports.IncludeMatchToken = IncludeMatchToken;\n  exports.DashMatchToken = DashMatchToken;\n  exports.PrefixMatchToken = PrefixMatchToken;\n  exports.SuffixMatchToken = SuffixMatchToken;\n  exports.SubstringMatchToken = SubstringMatchToken;\n  exports.ColumnToken = ColumnToken;\n  exports.WhitespaceToken = WhitespaceToken;\n  exports.CDOToken = CDOToken;\n  exports.CDCToken = CDCToken;\n  exports.ColonToken = ColonToken;\n  exports.SemicolonToken = SemicolonToken;\n  exports.CommaToken = CommaToken;\n  exports.OpenParenToken = OpenParenToken;\n  exports.CloseParenToken = CloseParenToken;\n  exports.OpenSquareToken = OpenSquareToken;\n  exports.CloseSquareToken = CloseSquareToken;\n  exports.OpenCurlyToken = OpenCurlyToken;\n  exports.CloseCurlyToken = CloseCurlyToken;\n  exports.EOFToken = EOFToken;\n  exports.CSSParserToken = CSSParserToken;\n  exports.GroupingToken = GroupingToken;\n});\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/common/selectorParser.ts\":\n/*!**********************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/common/selectorParser.ts ***!\n  \\**********************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.parseSelector = parseSelector;\nexports.splitSelectorByFrame = splitSelectorByFrame;\nexports.stringifySelector = stringifySelector;\nexports.customCSSNames = void 0;\n\nvar _cssParser = __webpack_require__(/*! ./cssParser */ \"./packages/playwright-core/src/server/common/cssParser.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nconst customCSSNames = new Set(['not', 'is', 'where', 'has', 'scope', 'light', 'visible', 'text', 'text-matches', 'text-is', 'has-text', 'above', 'below', 'right-of', 'left-of', 'near', 'nth-match']);\nexports.customCSSNames = customCSSNames;\n\nfunction parseSelector(selector) {\n  const result = parseSelectorString(selector);\n  const parts = result.parts.map(part => {\n    if (part.name === 'css' || part.name === 'css:light') {\n      if (part.name === 'css:light') part.body = ':light(' + part.body + ')';\n      const parsedCSS = (0, _cssParser.parseCSS)(part.body, customCSSNames);\n      return {\n        name: 'css',\n        body: parsedCSS.selector,\n        source: part.body\n      };\n    }\n\n    return { ...part,\n      source: part.body\n    };\n  });\n  return {\n    capture: result.capture,\n    parts\n  };\n}\n\nfunction splitSelectorByFrame(selectorText) {\n  const selector = parseSelector(selectorText);\n  const result = [];\n  let chunk = {\n    parts: []\n  };\n  let chunkStartIndex = 0;\n\n  for (let i = 0; i < selector.parts.length; ++i) {\n    const part = selector.parts[i];\n\n    if (part.name === 'control' && part.body === 'enter-frame') {\n      if (!chunk.parts.length) throw new Error('Selector cannot start with entering frame, select the iframe first');\n      result.push(chunk);\n      chunk = {\n        parts: []\n      };\n      chunkStartIndex = i + 1;\n      continue;\n    }\n\n    if (selector.capture === i) chunk.capture = i - chunkStartIndex;\n    chunk.parts.push(part);\n  }\n\n  if (!chunk.parts.length) throw new Error(`Selector cannot end with entering frame, while parsing selector ${selectorText}`);\n  result.push(chunk);\n  if (typeof selector.capture === 'number' && typeof result[result.length - 1].capture !== 'number') throw new Error(`Can not capture the selector before diving into the frame. Only use * after the last frame has been selected`);\n  return result;\n}\n\nfunction stringifySelector(selector) {\n  if (typeof selector === 'string') return selector;\n  return selector.parts.map((p, i) => {\n    const prefix = p.name === 'css' ? '' : p.name + '=';\n    return `${i === selector.capture ? '*' : ''}${prefix}${p.source}`;\n  }).join(' >> ');\n}\n\nfunction parseSelectorString(selector) {\n  let index = 0;\n  let quote;\n  let start = 0;\n  const result = {\n    parts: []\n  };\n\n  const append = () => {\n    const part = selector.substring(start, index).trim();\n    const eqIndex = part.indexOf('=');\n    let name;\n    let body;\n\n    if (eqIndex !== -1 && part.substring(0, eqIndex).trim().match(/^[a-zA-Z_0-9-+:*]+$/)) {\n      name = part.substring(0, eqIndex).trim();\n      body = part.substring(eqIndex + 1);\n    } else if (part.length > 1 && part[0] === '\"' && part[part.length - 1] === '\"') {\n      name = 'text';\n      body = part;\n    } else if (part.length > 1 && part[0] === \"'\" && part[part.length - 1] === \"'\") {\n      name = 'text';\n      body = part;\n    } else if (/^\\(*\\/\\//.test(part) || part.startsWith('..')) {\n      // If selector starts with '//' or '//' prefixed with multiple opening\n      // parenthesis, consider xpath. @see https://github.com/microsoft/playwright/issues/817\n      // If selector starts with '..', consider xpath as well.\n      name = 'xpath';\n      body = part;\n    } else {\n      name = 'css';\n      body = part;\n    }\n\n    let capture = false;\n\n    if (name[0] === '*') {\n      capture = true;\n      name = name.substring(1);\n    }\n\n    result.parts.push({\n      name,\n      body\n    });\n\n    if (capture) {\n      if (result.capture !== undefined) throw new Error(`Only one of the selectors can capture using * modifier`);\n      result.capture = result.parts.length - 1;\n    }\n  };\n\n  if (!selector.includes('>>')) {\n    index = selector.length;\n    append();\n    return result;\n  }\n\n  while (index < selector.length) {\n    const c = selector[index];\n\n    if (c === '\\\\' && index + 1 < selector.length) {\n      index += 2;\n    } else if (c === quote) {\n      quote = undefined;\n      index++;\n    } else if (!quote && (c === '\"' || c === '\\'' || c === '`')) {\n      quote = c;\n      index++;\n    } else if (!quote && c === '>' && selector[index + 1] === '>') {\n      append();\n      index += 2;\n      start = index;\n    } else {\n      index++;\n    }\n  }\n\n  append();\n  return result;\n}\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/injected/reactSelectorEngine.ts\":\n/*!*****************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/reactSelectorEngine.ts ***!\n  \\*****************************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.ReactEngine = void 0;\n\nvar _componentUtils = __webpack_require__(/*! ../common/componentUtils */ \"./packages/playwright-core/src/server/common/componentUtils.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nfunction getComponentName(reactElement) {\n  // React 16+\n  // @see https://github.com/baruchvlz/resq/blob/5c15a5e04d3f7174087248f5a158c3d6dcc1ec72/src/utils.js#L16\n  if (typeof reactElement.type === 'function') return reactElement.type.displayName || reactElement.type.name || 'Anonymous';\n  if (typeof reactElement.type === 'string') return reactElement.type; // React 15\n  // @see https://github.com/facebook/react/blob/2edf449803378b5c58168727d4f123de3ba5d37f/packages/react-devtools-shared/src/backend/legacy/renderer.js#L59\n\n  if (reactElement._currentElement) {\n    const elementType = reactElement._currentElement.type;\n    if (typeof elementType === 'string') return elementType;\n    if (typeof elementType === 'function') return elementType.displayName || elementType.name || 'Anonymous';\n  }\n\n  return '';\n}\n\nfunction getChildren(reactElement) {\n  // React 16+\n  // @see https://github.com/baruchvlz/resq/blob/5c15a5e04d3f7174087248f5a158c3d6dcc1ec72/src/utils.js#L192\n  if (reactElement.child) {\n    const children = [];\n\n    for (let child = reactElement.child; child; child = child.sibling) children.push(child);\n\n    return children;\n  } // React 15\n  // @see https://github.com/facebook/react/blob/2edf449803378b5c58168727d4f123de3ba5d37f/packages/react-devtools-shared/src/backend/legacy/renderer.js#L101\n\n\n  if (!reactElement._currentElement) return [];\n\n  const isKnownElement = reactElement => {\n    var _reactElement$_curren;\n\n    const elementType = (_reactElement$_curren = reactElement._currentElement) === null || _reactElement$_curren === void 0 ? void 0 : _reactElement$_curren.type;\n    return typeof elementType === 'function' || typeof elementType === 'string';\n  };\n\n  if (reactElement._renderedComponent) {\n    const child = reactElement._renderedComponent;\n    return isKnownElement(child) ? [child] : [];\n  }\n\n  if (reactElement._renderedChildren) return [...Object.values(reactElement._renderedChildren)].filter(isKnownElement);\n  return [];\n}\n\nfunction getProps(reactElement) {\n  var _reactElement$_curren2;\n\n  const props = // React 16+\n  reactElement.memoizedProps || ( // React 15\n  (_reactElement$_curren2 = reactElement._currentElement) === null || _reactElement$_curren2 === void 0 ? void 0 : _reactElement$_curren2.props);\n  if (!props || typeof props === 'string') return props;\n  const result = { ...props\n  };\n  delete result.children;\n  return result;\n}\n\nfunction buildComponentsTree(reactElement) {\n  var _reactElement$_render;\n\n  const treeNode = {\n    name: getComponentName(reactElement),\n    children: getChildren(reactElement).map(buildComponentsTree),\n    rootElements: [],\n    props: getProps(reactElement)\n  };\n  const rootElement = // React 16+\n  // @see https://github.com/baruchvlz/resq/blob/5c15a5e04d3f7174087248f5a158c3d6dcc1ec72/src/utils.js#L29\n  reactElement.stateNode || // React 15\n  reactElement._hostNode || ((_reactElement$_render = reactElement._renderedComponent) === null || _reactElement$_render === void 0 ? void 0 : _reactElement$_render._hostNode);\n\n  if (rootElement instanceof Element) {\n    treeNode.rootElements.push(rootElement);\n  } else {\n    for (const child of treeNode.children) treeNode.rootElements.push(...child.rootElements);\n  }\n\n  return treeNode;\n}\n\nfunction filterComponentsTree(treeNode, searchFn, result = []) {\n  if (searchFn(treeNode)) result.push(treeNode);\n\n  for (const child of treeNode.children) filterComponentsTree(child, searchFn, result);\n\n  return result;\n}\n\nfunction findReactRoots() {\n  const roots = [];\n  const walker = document.createTreeWalker(document, NodeFilter.SHOW_ELEMENT);\n\n  while (walker.nextNode()) {\n    const node = walker.currentNode; // @see https://github.com/baruchvlz/resq/blob/5c15a5e04d3f7174087248f5a158c3d6dcc1ec72/src/utils.js#L329\n\n    if (node.hasOwnProperty('_reactRootContainer')) roots.push(node._reactRootContainer._internalRoot.current);\n  } // Pre-react 16: query dom for `data-reactroot`\n  // @see https://github.com/facebook/react/issues/10971\n\n\n  for (const node of document.querySelectorAll('[data-reactroot]')) {\n    for (const key of Object.keys(node)) {\n      // @see https://github.com/baruchvlz/resq/blob/5c15a5e04d3f7174087248f5a158c3d6dcc1ec72/src/utils.js#L334\n      if (key.startsWith('__reactInternalInstance') || key.startsWith('__reactFiber')) roots.push(node[key]);\n    }\n  }\n\n  return roots;\n}\n\nconst ReactEngine = {\n  queryAll(scope, selector) {\n    const {\n      name,\n      attributes\n    } = (0, _componentUtils.parseComponentSelector)(selector);\n    const reactRoots = findReactRoots();\n    const trees = reactRoots.map(reactRoot => buildComponentsTree(reactRoot));\n    const treeNodes = trees.map(tree => filterComponentsTree(tree, treeNode => {\n      if (name && treeNode.name !== name) return false;\n      if (treeNode.rootElements.some(domNode => !scope.contains(domNode))) return false;\n\n      for (const attr of attributes) {\n        if (!(0, _componentUtils.checkComponentAttribute)(treeNode.props, attr)) return false;\n      }\n\n      return true;\n    })).flat();\n    const allRootElements = new Set();\n\n    for (const treeNode of treeNodes) {\n      for (const domNode of treeNode.rootElements) allRootElements.add(domNode);\n    }\n\n    return [...allRootElements];\n  }\n\n};\nexports.ReactEngine = ReactEngine;\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/injected/selectorEvaluator.ts\":\n/*!***************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/selectorEvaluator.ts ***!\n  \\***************************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.createLaxTextMatcher = createLaxTextMatcher;\nexports.createStrictTextMatcher = createStrictTextMatcher;\nexports.createRegexTextMatcher = createRegexTextMatcher;\nexports.elementText = elementText;\nexports.elementMatchesText = elementMatchesText;\nexports.parentElementOrShadowHost = parentElementOrShadowHost;\nexports.isVisible = isVisible;\nexports.SelectorEvaluatorImpl = void 0;\n\nvar _selectorParser = __webpack_require__(/*! ../common/selectorParser */ \"./packages/playwright-core/src/server/common/selectorParser.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nclass SelectorEvaluatorImpl {\n  constructor(extraEngines) {\n    this._engines = new Map();\n    this._cacheQueryCSS = new Map();\n    this._cacheMatches = new Map();\n    this._cacheQuery = new Map();\n    this._cacheMatchesSimple = new Map();\n    this._cacheMatchesParents = new Map();\n    this._cacheCallMatches = new Map();\n    this._cacheCallQuery = new Map();\n    this._cacheQuerySimple = new Map();\n    this._cacheText = new Map();\n    this._scoreMap = void 0;\n    this._retainCacheCounter = 0;\n\n    for (const [name, engine] of extraEngines) this._engines.set(name, engine);\n\n    this._engines.set('not', notEngine);\n\n    this._engines.set('is', isEngine);\n\n    this._engines.set('where', isEngine);\n\n    this._engines.set('has', hasEngine);\n\n    this._engines.set('scope', scopeEngine);\n\n    this._engines.set('light', lightEngine);\n\n    this._engines.set('visible', visibleEngine);\n\n    this._engines.set('text', textEngine);\n\n    this._engines.set('text-is', textIsEngine);\n\n    this._engines.set('text-matches', textMatchesEngine);\n\n    this._engines.set('has-text', hasTextEngine);\n\n    this._engines.set('right-of', createPositionEngine('right-of', boxRightOf));\n\n    this._engines.set('left-of', createPositionEngine('left-of', boxLeftOf));\n\n    this._engines.set('above', createPositionEngine('above', boxAbove));\n\n    this._engines.set('below', createPositionEngine('below', boxBelow));\n\n    this._engines.set('near', createPositionEngine('near', boxNear));\n\n    this._engines.set('nth-match', nthMatchEngine);\n\n    const allNames = [...this._engines.keys()];\n    allNames.sort();\n    const parserNames = [..._selectorParser.customCSSNames];\n    parserNames.sort();\n    if (allNames.join('|') !== parserNames.join('|')) throw new Error(`Please keep customCSSNames in sync with evaluator engines: ${allNames.join('|')} vs ${parserNames.join('|')}`);\n  }\n\n  begin() {\n    ++this._retainCacheCounter;\n  }\n\n  end() {\n    --this._retainCacheCounter;\n\n    if (!this._retainCacheCounter) {\n      this._cacheQueryCSS.clear();\n\n      this._cacheMatches.clear();\n\n      this._cacheQuery.clear();\n\n      this._cacheMatchesSimple.clear();\n\n      this._cacheMatchesParents.clear();\n\n      this._cacheCallMatches.clear();\n\n      this._cacheCallQuery.clear();\n\n      this._cacheQuerySimple.clear();\n\n      this._cacheText.clear();\n    }\n  }\n\n  _cached(cache, main, rest, cb) {\n    if (!cache.has(main)) cache.set(main, []);\n    const entries = cache.get(main);\n    const entry = entries.find(e => rest.every((value, index) => e.rest[index] === value));\n    if (entry) return entry.result;\n    const result = cb();\n    entries.push({\n      rest,\n      result\n    });\n    return result;\n  }\n\n  _checkSelector(s) {\n    const wellFormed = typeof s === 'object' && s && (Array.isArray(s) || 'simples' in s && s.simples.length);\n    if (!wellFormed) throw new Error(`Malformed selector \"${s}\"`);\n    return s;\n  }\n\n  matches(element, s, context) {\n    const selector = this._checkSelector(s);\n\n    this.begin();\n\n    try {\n      return this._cached(this._cacheMatches, element, [selector, context.scope, context.pierceShadow], () => {\n        if (Array.isArray(selector)) return this._matchesEngine(isEngine, element, selector, context);\n        if (!this._matchesSimple(element, selector.simples[selector.simples.length - 1].selector, context)) return false;\n        return this._matchesParents(element, selector, selector.simples.length - 2, context);\n      });\n    } finally {\n      this.end();\n    }\n  }\n\n  query(context, s) {\n    const selector = this._checkSelector(s);\n\n    this.begin();\n\n    try {\n      return this._cached(this._cacheQuery, selector, [context.scope, context.pierceShadow], () => {\n        if (Array.isArray(selector)) return this._queryEngine(isEngine, context, selector); // query() recursively calls itself, so we set up a new map for this particular query() call.\n\n        const previousScoreMap = this._scoreMap;\n        this._scoreMap = new Map();\n\n        let elements = this._querySimple(context, selector.simples[selector.simples.length - 1].selector);\n\n        elements = elements.filter(element => this._matchesParents(element, selector, selector.simples.length - 2, context));\n\n        if (this._scoreMap.size) {\n          elements.sort((a, b) => {\n            const aScore = this._scoreMap.get(a);\n\n            const bScore = this._scoreMap.get(b);\n\n            if (aScore === bScore) return 0;\n            if (aScore === undefined) return 1;\n            if (bScore === undefined) return -1;\n            return aScore - bScore;\n          });\n        }\n\n        this._scoreMap = previousScoreMap;\n        return elements;\n      });\n    } finally {\n      this.end();\n    }\n  }\n\n  _markScore(element, score) {\n    // HACK ALERT: temporary marks an element with a score, to be used\n    // for sorting at the end of the query().\n    if (this._scoreMap) this._scoreMap.set(element, score);\n  }\n\n  _matchesSimple(element, simple, context) {\n    return this._cached(this._cacheMatchesSimple, element, [simple, context.scope, context.pierceShadow], () => {\n      const isPossiblyScopeClause = simple.functions.some(f => f.name === 'scope' || f.name === 'is');\n      if (!isPossiblyScopeClause && element === context.scope) return false;\n      if (simple.css && !this._matchesCSS(element, simple.css)) return false;\n\n      for (const func of simple.functions) {\n        if (!this._matchesEngine(this._getEngine(func.name), element, func.args, context)) return false;\n      }\n\n      return true;\n    });\n  }\n\n  _querySimple(context, simple) {\n    if (!simple.functions.length) return this._queryCSS(context, simple.css || '*');\n    return this._cached(this._cacheQuerySimple, simple, [context.scope, context.pierceShadow], () => {\n      let css = simple.css;\n      const funcs = simple.functions;\n      if (css === '*' && funcs.length) css = undefined;\n      let elements;\n      let firstIndex = -1;\n\n      if (css !== undefined) {\n        elements = this._queryCSS(context, css);\n      } else {\n        firstIndex = funcs.findIndex(func => this._getEngine(func.name).query !== undefined);\n        if (firstIndex === -1) firstIndex = 0;\n        elements = this._queryEngine(this._getEngine(funcs[firstIndex].name), context, funcs[firstIndex].args);\n      }\n\n      for (let i = 0; i < funcs.length; i++) {\n        if (i === firstIndex) continue;\n\n        const engine = this._getEngine(funcs[i].name);\n\n        if (engine.matches !== undefined) elements = elements.filter(e => this._matchesEngine(engine, e, funcs[i].args, context));\n      }\n\n      for (let i = 0; i < funcs.length; i++) {\n        if (i === firstIndex) continue;\n\n        const engine = this._getEngine(funcs[i].name);\n\n        if (engine.matches === undefined) elements = elements.filter(e => this._matchesEngine(engine, e, funcs[i].args, context));\n      }\n\n      return elements;\n    });\n  }\n\n  _matchesParents(element, complex, index, context) {\n    if (index < 0) return true;\n    return this._cached(this._cacheMatchesParents, element, [complex, index, context.scope, context.pierceShadow], () => {\n      const {\n        selector: simple,\n        combinator\n      } = complex.simples[index];\n\n      if (combinator === '>') {\n        const parent = parentElementOrShadowHostInContext(element, context);\n        if (!parent || !this._matchesSimple(parent, simple, context)) return false;\n        return this._matchesParents(parent, complex, index - 1, context);\n      }\n\n      if (combinator === '+') {\n        const previousSibling = previousSiblingInContext(element, context);\n        if (!previousSibling || !this._matchesSimple(previousSibling, simple, context)) return false;\n        return this._matchesParents(previousSibling, complex, index - 1, context);\n      }\n\n      if (combinator === '') {\n        let parent = parentElementOrShadowHostInContext(element, context);\n\n        while (parent) {\n          if (this._matchesSimple(parent, simple, context)) {\n            if (this._matchesParents(parent, complex, index - 1, context)) return true;\n            if (complex.simples[index - 1].combinator === '') break;\n          }\n\n          parent = parentElementOrShadowHostInContext(parent, context);\n        }\n\n        return false;\n      }\n\n      if (combinator === '~') {\n        let previousSibling = previousSiblingInContext(element, context);\n\n        while (previousSibling) {\n          if (this._matchesSimple(previousSibling, simple, context)) {\n            if (this._matchesParents(previousSibling, complex, index - 1, context)) return true;\n            if (complex.simples[index - 1].combinator === '~') break;\n          }\n\n          previousSibling = previousSiblingInContext(previousSibling, context);\n        }\n\n        return false;\n      }\n\n      if (combinator === '>=') {\n        let parent = element;\n\n        while (parent) {\n          if (this._matchesSimple(parent, simple, context)) {\n            if (this._matchesParents(parent, complex, index - 1, context)) return true;\n            if (complex.simples[index - 1].combinator === '') break;\n          }\n\n          parent = parentElementOrShadowHostInContext(parent, context);\n        }\n\n        return false;\n      }\n\n      throw new Error(`Unsupported combinator \"${combinator}\"`);\n    });\n  }\n\n  _matchesEngine(engine, element, args, context) {\n    if (engine.matches) return this._callMatches(engine, element, args, context);\n    if (engine.query) return this._callQuery(engine, args, context).includes(element);\n    throw new Error(`Selector engine should implement \"matches\" or \"query\"`);\n  }\n\n  _queryEngine(engine, context, args) {\n    if (engine.query) return this._callQuery(engine, args, context);\n    if (engine.matches) return this._queryCSS(context, '*').filter(element => this._callMatches(engine, element, args, context));\n    throw new Error(`Selector engine should implement \"matches\" or \"query\"`);\n  }\n\n  _callMatches(engine, element, args, context) {\n    return this._cached(this._cacheCallMatches, element, [engine, context.scope, context.pierceShadow, ...args], () => {\n      return engine.matches(element, args, context, this);\n    });\n  }\n\n  _callQuery(engine, args, context) {\n    return this._cached(this._cacheCallQuery, engine, [context.scope, context.pierceShadow, ...args], () => {\n      return engine.query(context, args, this);\n    });\n  }\n\n  _matchesCSS(element, css) {\n    return element.matches(css);\n  }\n\n  _queryCSS(context, css) {\n    return this._cached(this._cacheQueryCSS, css, [context.scope, context.pierceShadow], () => {\n      let result = [];\n\n      function query(root) {\n        result = result.concat([...root.querySelectorAll(css)]);\n        if (!context.pierceShadow) return;\n        if (root.shadowRoot) query(root.shadowRoot);\n\n        for (const element of root.querySelectorAll('*')) {\n          if (element.shadowRoot) query(element.shadowRoot);\n        }\n      }\n\n      query(context.scope);\n      return result;\n    });\n  }\n\n  _getEngine(name) {\n    const engine = this._engines.get(name);\n\n    if (!engine) throw new Error(`Unknown selector engine \"${name}\"`);\n    return engine;\n  }\n\n}\n\nexports.SelectorEvaluatorImpl = SelectorEvaluatorImpl;\nconst isEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length === 0) throw new Error(`\"is\" engine expects non-empty selector list`);\n    return args.some(selector => evaluator.matches(element, selector, context));\n  },\n\n  query(context, args, evaluator) {\n    if (args.length === 0) throw new Error(`\"is\" engine expects non-empty selector list`);\n    let elements = [];\n\n    for (const arg of args) elements = elements.concat(evaluator.query(context, arg));\n\n    return args.length === 1 ? elements : sortInDOMOrder(elements);\n  }\n\n};\nconst hasEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length === 0) throw new Error(`\"has\" engine expects non-empty selector list`);\n    return evaluator.query({ ...context,\n      scope: element\n    }, args).length > 0;\n  } // TODO: we do not implement \"relative selectors\", as in \"div:has(> span)\" or \"div:has(+ span)\".\n  // TODO: we can implement efficient \"query\" by matching \"args\" and returning\n  // all parents/descendants, just have to be careful with the \":scope\" matching.\n\n\n};\nconst scopeEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length !== 0) throw new Error(`\"scope\" engine expects no arguments`);\n    if (context.scope.nodeType === 9\n    /* Node.DOCUMENT_NODE */\n    ) return element === context.scope.documentElement;\n    return element === context.scope;\n  },\n\n  query(context, args, evaluator) {\n    if (args.length !== 0) throw new Error(`\"scope\" engine expects no arguments`);\n\n    if (context.scope.nodeType === 9\n    /* Node.DOCUMENT_NODE */\n    ) {\n      const root = context.scope.documentElement;\n      return root ? [root] : [];\n    }\n\n    if (context.scope.nodeType === 1\n    /* Node.ELEMENT_NODE */\n    ) return [context.scope];\n    return [];\n  }\n\n};\nconst notEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length === 0) throw new Error(`\"not\" engine expects non-empty selector list`);\n    return !evaluator.matches(element, args, context);\n  }\n\n};\nconst lightEngine = {\n  query(context, args, evaluator) {\n    return evaluator.query({ ...context,\n      pierceShadow: false\n    }, args);\n  },\n\n  matches(element, args, context, evaluator) {\n    return evaluator.matches(element, args, { ...context,\n      pierceShadow: false\n    });\n  }\n\n};\nconst visibleEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length) throw new Error(`\"visible\" engine expects no arguments`);\n    return isVisible(element);\n  }\n\n};\nconst textEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length !== 1 || typeof args[0] !== 'string') throw new Error(`\"text\" engine expects a single string`);\n    const matcher = createLaxTextMatcher(args[0]);\n    return elementMatchesText(evaluator, element, matcher) === 'self';\n  }\n\n};\nconst textIsEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length !== 1 || typeof args[0] !== 'string') throw new Error(`\"text-is\" engine expects a single string`);\n    const matcher = createStrictTextMatcher(args[0]);\n    return elementMatchesText(evaluator, element, matcher) !== 'none';\n  }\n\n};\nconst textMatchesEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length === 0 || typeof args[0] !== 'string' || args.length > 2 || args.length === 2 && typeof args[1] !== 'string') throw new Error(`\"text-matches\" engine expects a regexp body and optional regexp flags`);\n    const matcher = createRegexTextMatcher(args[0], args.length === 2 ? args[1] : undefined);\n    return elementMatchesText(evaluator, element, matcher) === 'self';\n  }\n\n};\nconst hasTextEngine = {\n  matches(element, args, context, evaluator) {\n    if (args.length !== 1 || typeof args[0] !== 'string') throw new Error(`\"has-text\" engine expects a single string`);\n    if (shouldSkipForTextMatching(element)) return false;\n    const matcher = createLaxTextMatcher(args[0]);\n    return matcher(elementText(evaluator, element));\n  }\n\n};\n\nfunction createLaxTextMatcher(text) {\n  text = text.trim().replace(/\\s+/g, ' ').toLowerCase();\n  return elementText => {\n    const s = elementText.full.trim().replace(/\\s+/g, ' ').toLowerCase();\n    return s.includes(text);\n  };\n}\n\nfunction createStrictTextMatcher(text) {\n  text = text.trim().replace(/\\s+/g, ' ');\n  return elementText => {\n    if (!text && !elementText.immediate.length) return true;\n    return elementText.immediate.some(s => s.trim().replace(/\\s+/g, ' ') === text);\n  };\n}\n\nfunction createRegexTextMatcher(source, flags) {\n  const re = new RegExp(source, flags);\n  return elementText => {\n    return re.test(elementText.full);\n  };\n}\n\nfunction shouldSkipForTextMatching(element) {\n  return element.nodeName === 'SCRIPT' || element.nodeName === 'STYLE' || document.head && document.head.contains(element);\n}\n\nfunction elementText(evaluator, root) {\n  let value = evaluator._cacheText.get(root);\n\n  if (value === undefined) {\n    value = {\n      full: '',\n      immediate: []\n    };\n\n    if (!shouldSkipForTextMatching(root)) {\n      let currentImmediate = '';\n\n      if (root instanceof HTMLInputElement && (root.type === 'submit' || root.type === 'button')) {\n        value = {\n          full: root.value,\n          immediate: [root.value]\n        };\n      } else {\n        for (let child = root.firstChild; child; child = child.nextSibling) {\n          if (child.nodeType === Node.TEXT_NODE) {\n            value.full += child.nodeValue || '';\n            currentImmediate += child.nodeValue || '';\n          } else {\n            if (currentImmediate) value.immediate.push(currentImmediate);\n            currentImmediate = '';\n            if (child.nodeType === Node.ELEMENT_NODE) value.full += elementText(evaluator, child).full;\n          }\n        }\n\n        if (currentImmediate) value.immediate.push(currentImmediate);\n        if (root.shadowRoot) value.full += elementText(evaluator, root.shadowRoot).full;\n      }\n    }\n\n    evaluator._cacheText.set(root, value);\n  }\n\n  return value;\n}\n\nfunction elementMatchesText(evaluator, element, matcher) {\n  if (shouldSkipForTextMatching(element)) return 'none';\n  if (!matcher(elementText(evaluator, element))) return 'none';\n\n  for (let child = element.firstChild; child; child = child.nextSibling) {\n    if (child.nodeType === Node.ELEMENT_NODE && matcher(elementText(evaluator, child))) return 'selfAndChildren';\n  }\n\n  if (element.shadowRoot && matcher(elementText(evaluator, element.shadowRoot))) return 'selfAndChildren';\n  return 'self';\n}\n\nfunction boxRightOf(box1, box2, maxDistance) {\n  const distance = box1.left - box2.right;\n  if (distance < 0 || maxDistance !== undefined && distance > maxDistance) return;\n  return distance + Math.max(box2.bottom - box1.bottom, 0) + Math.max(box1.top - box2.top, 0);\n}\n\nfunction boxLeftOf(box1, box2, maxDistance) {\n  const distance = box2.left - box1.right;\n  if (distance < 0 || maxDistance !== undefined && distance > maxDistance) return;\n  return distance + Math.max(box2.bottom - box1.bottom, 0) + Math.max(box1.top - box2.top, 0);\n}\n\nfunction boxAbove(box1, box2, maxDistance) {\n  const distance = box2.top - box1.bottom;\n  if (distance < 0 || maxDistance !== undefined && distance > maxDistance) return;\n  return distance + Math.max(box1.left - box2.left, 0) + Math.max(box2.right - box1.right, 0);\n}\n\nfunction boxBelow(box1, box2, maxDistance) {\n  const distance = box1.top - box2.bottom;\n  if (distance < 0 || maxDistance !== undefined && distance > maxDistance) return;\n  return distance + Math.max(box1.left - box2.left, 0) + Math.max(box2.right - box1.right, 0);\n}\n\nfunction boxNear(box1, box2, maxDistance) {\n  const kThreshold = maxDistance === undefined ? 50 : maxDistance;\n  let score = 0;\n  if (box1.left - box2.right >= 0) score += box1.left - box2.right;\n  if (box2.left - box1.right >= 0) score += box2.left - box1.right;\n  if (box2.top - box1.bottom >= 0) score += box2.top - box1.bottom;\n  if (box1.top - box2.bottom >= 0) score += box1.top - box2.bottom;\n  return score > kThreshold ? undefined : score;\n}\n\nfunction createPositionEngine(name, scorer) {\n  return {\n    matches(element, args, context, evaluator) {\n      const maxDistance = args.length && typeof args[args.length - 1] === 'number' ? args[args.length - 1] : undefined;\n      const queryArgs = maxDistance === undefined ? args : args.slice(0, args.length - 1);\n      if (args.length < 1 + (maxDistance === undefined ? 0 : 1)) throw new Error(`\"${name}\" engine expects a selector list and optional maximum distance in pixels`);\n      const box = element.getBoundingClientRect();\n      let bestScore;\n\n      for (const e of evaluator.query(context, queryArgs)) {\n        if (e === element) continue;\n        const score = scorer(box, e.getBoundingClientRect(), maxDistance);\n        if (score === undefined) continue;\n        if (bestScore === undefined || score < bestScore) bestScore = score;\n      }\n\n      if (bestScore === undefined) return false;\n\n      evaluator._markScore(element, bestScore);\n\n      return true;\n    }\n\n  };\n}\n\nconst nthMatchEngine = {\n  query(context, args, evaluator) {\n    let index = args[args.length - 1];\n    if (args.length < 2) throw new Error(`\"nth-match\" engine expects non-empty selector list and an index argument`);\n    if (typeof index !== 'number' || index < 1) throw new Error(`\"nth-match\" engine expects a one-based index as the last argument`);\n    const elements = isEngine.query(context, args.slice(0, args.length - 1), evaluator);\n    index--; // one-based\n\n    return index < elements.length ? [elements[index]] : [];\n  }\n\n};\n\nfunction parentElementOrShadowHost(element) {\n  if (element.parentElement) return element.parentElement;\n  if (!element.parentNode) return;\n  if (element.parentNode.nodeType === Node.DOCUMENT_FRAGMENT_NODE && element.parentNode.host) return element.parentNode.host;\n}\n\nfunction parentElementOrShadowHostInContext(element, context) {\n  if (element === context.scope) return;\n  if (!context.pierceShadow) return element.parentElement || undefined;\n  return parentElementOrShadowHost(element);\n}\n\nfunction previousSiblingInContext(element, context) {\n  if (element === context.scope) return;\n  return element.previousElementSibling || undefined;\n}\n\nfunction isVisible(element) {\n  // Note: this logic should be similar to waitForDisplayedAtStablePosition() to avoid surprises.\n  if (!element.ownerDocument || !element.ownerDocument.defaultView) return true;\n  const style = element.ownerDocument.defaultView.getComputedStyle(element);\n  if (!style || style.visibility === 'hidden') return false;\n  const rect = element.getBoundingClientRect();\n  return rect.width > 0 && rect.height > 0;\n}\n\nfunction sortInDOMOrder(elements) {\n  const elementToEntry = new Map();\n  const roots = [];\n  const result = [];\n\n  function append(element) {\n    let entry = elementToEntry.get(element);\n    if (entry) return entry;\n    const parent = parentElementOrShadowHost(element);\n\n    if (parent) {\n      const parentEntry = append(parent);\n      parentEntry.children.push(element);\n    } else {\n      roots.push(element);\n    }\n\n    entry = {\n      children: [],\n      taken: false\n    };\n    elementToEntry.set(element, entry);\n    return entry;\n  }\n\n  elements.forEach(e => append(e).taken = true);\n\n  function visit(element) {\n    const entry = elementToEntry.get(element);\n    if (entry.taken) result.push(element);\n\n    if (entry.children.length > 1) {\n      const set = new Set(entry.children);\n      entry.children = [];\n      let child = element.firstElementChild;\n\n      while (child && entry.children.length < set.size) {\n        if (set.has(child)) entry.children.push(child);\n        child = child.nextElementSibling;\n      }\n\n      child = element.shadowRoot ? element.shadowRoot.firstElementChild : null;\n\n      while (child && entry.children.length < set.size) {\n        if (set.has(child)) entry.children.push(child);\n        child = child.nextElementSibling;\n      }\n    }\n\n    entry.children.forEach(visit);\n  }\n\n  roots.forEach(visit);\n  return result;\n}\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/injected/selectorGenerator.ts\":\n/*!***************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/selectorGenerator.ts ***!\n  \\***************************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.querySelector = querySelector;\nexports.generateSelector = generateSelector;\n\nvar _selectorEvaluator = __webpack_require__(/*! ./selectorEvaluator */ \"./packages/playwright-core/src/server/injected/selectorEvaluator.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nconst cacheAllowText = new Map();\nconst cacheDisallowText = new Map();\n\nfunction querySelector(injectedScript, selector, ownerDocument) {\n  try {\n    const parsedSelector = injectedScript.parseSelector(selector);\n    return {\n      selector,\n      elements: injectedScript.querySelectorAll(parsedSelector, ownerDocument)\n    };\n  } catch (e) {\n    return {\n      selector,\n      elements: []\n    };\n  }\n}\n\nfunction generateSelector(injectedScript, targetElement) {\n  injectedScript._evaluator.begin();\n\n  try {\n    targetElement = targetElement.closest('button,select,input,[role=button],[role=checkbox],[role=radio]') || targetElement;\n    const targetTokens = generateSelectorFor(injectedScript, targetElement);\n    const bestTokens = targetTokens || [cssFallback(injectedScript, targetElement)];\n    const selector = joinTokens(bestTokens);\n    const parsedSelector = injectedScript.parseSelector(selector);\n    return {\n      selector,\n      elements: injectedScript.querySelectorAll(parsedSelector, targetElement.ownerDocument)\n    };\n  } finally {\n    cacheAllowText.clear();\n    cacheDisallowText.clear();\n\n    injectedScript._evaluator.end();\n  }\n}\n\nfunction filterRegexTokens(textCandidates) {\n  // Filter out regex-based selectors for better performance.\n  return textCandidates.filter(c => c[0].selector[0] !== '/');\n}\n\nfunction generateSelectorFor(injectedScript, targetElement) {\n  if (targetElement.ownerDocument.documentElement === targetElement) return [{\n    engine: 'css',\n    selector: 'html',\n    score: 1\n  }];\n\n  const calculate = (element, allowText) => {\n    const allowNthMatch = element === targetElement;\n    let textCandidates = allowText ? buildTextCandidates(injectedScript, element, element === targetElement).map(token => [token]) : [];\n\n    if (element !== targetElement) {\n      // Do not use regex for parent elements (for performance).\n      textCandidates = filterRegexTokens(textCandidates);\n    }\n\n    const noTextCandidates = buildCandidates(injectedScript, element).map(token => [token]); // First check all text and non-text candidates for the element.\n\n    let result = chooseFirstSelector(injectedScript, targetElement.ownerDocument, element, [...textCandidates, ...noTextCandidates], allowNthMatch); // Do not use regex for chained selectors (for performance).\n\n    textCandidates = filterRegexTokens(textCandidates);\n\n    const checkWithText = textCandidatesToUse => {\n      // Use the deepest possible text selector - works pretty good and saves on compute time.\n      const allowParentText = allowText && !textCandidatesToUse.length;\n      const candidates = [...textCandidatesToUse, ...noTextCandidates].filter(c => {\n        if (!result) return true;\n        return combineScores(c) < combineScores(result);\n      }); // This is best theoretically possible candidate from the current parent.\n      // We use the fact that widening the scope to grand-parent makes any selector\n      // even less likely to match.\n\n      let bestPossibleInParent = candidates[0];\n      if (!bestPossibleInParent) return;\n\n      for (let parent = parentElementOrShadowHost(element); parent; parent = parentElementOrShadowHost(parent)) {\n        const parentTokens = calculateCached(parent, allowParentText);\n        if (!parentTokens) continue; // Even the best selector won't be too good - skip this parent.\n\n        if (result && combineScores([...parentTokens, ...bestPossibleInParent]) >= combineScores(result)) continue; // Update the best candidate that finds \"element\" in the \"parent\".\n\n        bestPossibleInParent = chooseFirstSelector(injectedScript, parent, element, candidates, allowNthMatch);\n        if (!bestPossibleInParent) return;\n        const combined = [...parentTokens, ...bestPossibleInParent];\n        if (!result || combineScores(combined) < combineScores(result)) result = combined;\n      }\n    };\n\n    checkWithText(textCandidates); // Allow skipping text on the target element, and using text on one of the parents.\n\n    if (element === targetElement && textCandidates.length) checkWithText([]);\n    return result;\n  };\n\n  const calculateCached = (element, allowText) => {\n    const cache = allowText ? cacheAllowText : cacheDisallowText;\n    let value = cache.get(element);\n\n    if (value === undefined) {\n      value = calculate(element, allowText);\n      cache.set(element, value);\n    }\n\n    return value;\n  };\n\n  return calculateCached(targetElement, true);\n}\n\nfunction buildCandidates(injectedScript, element) {\n  const candidates = [];\n\n  for (const attribute of ['data-testid', 'data-test-id', 'data-test']) {\n    if (element.hasAttribute(attribute)) candidates.push({\n      engine: 'css',\n      selector: `[${attribute}=${quoteString(element.getAttribute(attribute))}]`,\n      score: 1\n    });\n  }\n\n  if (element.nodeName === 'INPUT') {\n    const input = element;\n    if (input.placeholder) candidates.push({\n      engine: 'css',\n      selector: `[placeholder=${quoteString(input.placeholder)}]`,\n      score: 10\n    });\n  }\n\n  if (element.hasAttribute('aria-label')) candidates.push({\n    engine: 'css',\n    selector: `[aria-label=${quoteString(element.getAttribute('aria-label'))}]`,\n    score: 10\n  });\n  if (element.getAttribute('alt') && ['APPLET', 'AREA', 'IMG', 'INPUT'].includes(element.nodeName)) candidates.push({\n    engine: 'css',\n    selector: `${element.nodeName.toLowerCase()}[alt=${quoteString(element.getAttribute('alt'))}]`,\n    score: 10\n  });\n  if (element.hasAttribute('role')) candidates.push({\n    engine: 'css',\n    selector: `${element.nodeName.toLocaleLowerCase()}[role=${quoteString(element.getAttribute('role'))}]`,\n    score: 50\n  });\n  if (element.getAttribute('name') && ['BUTTON', 'FORM', 'FIELDSET', 'IFRAME', 'INPUT', 'KEYGEN', 'OBJECT', 'OUTPUT', 'SELECT', 'TEXTAREA', 'MAP', 'META', 'PARAM'].includes(element.nodeName)) candidates.push({\n    engine: 'css',\n    selector: `${element.nodeName.toLowerCase()}[name=${quoteString(element.getAttribute('name'))}]`,\n    score: 50\n  });\n\n  if (['INPUT', 'TEXTAREA'].includes(element.nodeName) && element.getAttribute('type') !== 'hidden') {\n    if (element.getAttribute('type')) candidates.push({\n      engine: 'css',\n      selector: `${element.nodeName.toLowerCase()}[type=${quoteString(element.getAttribute('type'))}]`,\n      score: 50\n    });\n  }\n\n  if (['INPUT', 'TEXTAREA', 'SELECT'].includes(element.nodeName)) candidates.push({\n    engine: 'css',\n    selector: element.nodeName.toLowerCase(),\n    score: 50\n  });\n  const idAttr = element.getAttribute('id');\n  if (idAttr && !isGuidLike(idAttr)) candidates.push({\n    engine: 'css',\n    selector: makeSelectorForId(idAttr),\n    score: 100\n  });\n  candidates.push({\n    engine: 'css',\n    selector: element.nodeName.toLocaleLowerCase(),\n    score: 200\n  });\n  return candidates;\n}\n\nfunction buildTextCandidates(injectedScript, element, allowHasText) {\n  if (element.nodeName === 'SELECT') return [];\n  const text = (0, _selectorEvaluator.elementText)(injectedScript._evaluator, element).full.trim().replace(/\\s+/g, ' ').substring(0, 80);\n  if (!text) return [];\n  const candidates = [];\n  let escaped = text;\n  if (text.includes('\"') || text.includes('>>') || text[0] === '/') escaped = `/.*${escapeForRegex(text)}.*/`;\n  candidates.push({\n    engine: 'text',\n    selector: escaped,\n    score: 10\n  });\n\n  if (allowHasText && escaped === text) {\n    let prefix = element.nodeName.toLocaleLowerCase();\n    if (element.hasAttribute('role')) prefix += `[role=${quoteString(element.getAttribute('role'))}]`;\n    candidates.push({\n      engine: 'css',\n      selector: `${prefix}:has-text(\"${text}\")`,\n      score: 30\n    });\n  }\n\n  return candidates;\n}\n\nfunction parentElementOrShadowHost(element) {\n  if (element.parentElement) return element.parentElement;\n  if (!element.parentNode) return null;\n  if (element.parentNode.nodeType === Node.DOCUMENT_FRAGMENT_NODE && element.parentNode.host) return element.parentNode.host;\n  return null;\n}\n\nfunction makeSelectorForId(id) {\n  return /^[a-zA-Z][a-zA-Z0-9\\-\\_]+$/.test(id) ? '#' + id : `[id=\"${id}\"]`;\n}\n\nfunction cssFallback(injectedScript, targetElement) {\n  const kFallbackScore = 10000000;\n  const root = targetElement.ownerDocument;\n  const tokens = [];\n\n  function uniqueCSSSelector(prefix) {\n    const path = tokens.slice();\n    if (prefix) path.unshift(prefix);\n    const selector = path.join(' ');\n    const parsedSelector = injectedScript.parseSelector(selector);\n    const node = injectedScript.querySelector(parsedSelector, targetElement.ownerDocument, false);\n    return node === targetElement ? selector : undefined;\n  }\n\n  for (let element = targetElement; element && element !== root; element = parentElementOrShadowHost(element)) {\n    const nodeName = element.nodeName.toLowerCase(); // Element ID is the strongest signal, use it.\n\n    let bestTokenForLevel = '';\n\n    if (element.id) {\n      const token = makeSelectorForId(element.id);\n      const selector = uniqueCSSSelector(token);\n      if (selector) return {\n        engine: 'css',\n        selector,\n        score: kFallbackScore\n      };\n      bestTokenForLevel = token;\n    }\n\n    const parent = element.parentNode; // Combine class names until unique.\n\n    const classes = [...element.classList];\n\n    for (let i = 0; i < classes.length; ++i) {\n      const token = '.' + classes.slice(0, i + 1).join('.');\n      const selector = uniqueCSSSelector(token);\n      if (selector) return {\n        engine: 'css',\n        selector,\n        score: kFallbackScore\n      }; // Even if not unique, does this subset of classes uniquely identify node as a child?\n\n      if (!bestTokenForLevel && parent) {\n        const sameClassSiblings = parent.querySelectorAll(token);\n        if (sameClassSiblings.length === 1) bestTokenForLevel = token;\n      }\n    } // Ordinal is the weakest signal.\n\n\n    if (parent) {\n      const siblings = [...parent.children];\n      const sameTagSiblings = siblings.filter(sibling => sibling.nodeName.toLowerCase() === nodeName);\n      const token = sameTagSiblings.indexOf(element) === 0 ? nodeName : `${nodeName}:nth-child(${1 + siblings.indexOf(element)})`;\n      const selector = uniqueCSSSelector(token);\n      if (selector) return {\n        engine: 'css',\n        selector,\n        score: kFallbackScore\n      };\n      if (!bestTokenForLevel) bestTokenForLevel = token;\n    } else if (!bestTokenForLevel) {\n      bestTokenForLevel = nodeName;\n    }\n\n    tokens.unshift(bestTokenForLevel);\n  }\n\n  return {\n    engine: 'css',\n    selector: uniqueCSSSelector(),\n    score: kFallbackScore\n  };\n}\n\nfunction escapeForRegex(text) {\n  return text.replace(/[.*+?^>${}()|[\\]\\\\]/g, '\\\\$&');\n}\n\nfunction quoteString(text) {\n  return `\"${text.replace(/\"/g, '\\\\\"').replace(/\\n/g, '\\\\n')}\"`;\n}\n\nfunction joinTokens(tokens) {\n  const parts = [];\n  let lastEngine = '';\n\n  for (const {\n    engine,\n    selector\n  } of tokens) {\n    if (parts.length && (lastEngine !== 'css' || engine !== 'css' || selector.startsWith(':nth-match('))) parts.push('>>');\n    lastEngine = engine;\n    if (engine === 'css') parts.push(selector);else parts.push(`${engine}=${selector}`);\n  }\n\n  return parts.join(' ');\n}\n\nfunction combineScores(tokens) {\n  let score = 0;\n\n  for (let i = 0; i < tokens.length; i++) score += tokens[i].score * (tokens.length - i);\n\n  return score;\n}\n\nfunction chooseFirstSelector(injectedScript, scope, targetElement, selectors, allowNthMatch) {\n  const joined = selectors.map(tokens => ({\n    tokens,\n    score: combineScores(tokens)\n  }));\n  joined.sort((a, b) => a.score - b.score);\n  let bestWithIndex = null;\n\n  for (const {\n    tokens\n  } of joined) {\n    const parsedSelector = injectedScript.parseSelector(joinTokens(tokens));\n    const result = injectedScript.querySelectorAll(parsedSelector, scope);\n    const index = result.indexOf(targetElement);\n\n    if (index === 0) {\n      // We are the first match - found the best selector.\n      return tokens;\n    } // Otherwise, perhaps we can get nth-match?\n\n\n    if (!allowNthMatch || bestWithIndex || index === -1 || result.length > 5) continue; // To use nth-match, we must convert everything to css.\n\n    const allCss = tokens.map(token => {\n      if (token.engine !== 'text') return token;\n      if (token.selector.startsWith('/') && token.selector.endsWith('/')) return {\n        engine: 'css',\n        selector: `:text-matches(\"${token.selector.substring(1, token.selector.length - 1)}\")`,\n        score: token.score\n      };\n      return {\n        engine: 'css',\n        selector: `:text(\"${token.selector}\")`,\n        score: token.score\n      };\n    });\n    const combined = joinTokens(allCss);\n    bestWithIndex = [{\n      engine: 'css',\n      selector: `:nth-match(${combined}, ${index + 1})`,\n      score: combineScores(allCss) + 1000\n    }];\n  }\n\n  return bestWithIndex;\n}\n\nfunction isGuidLike(id) {\n  let lastCharacterType;\n  let transitionCount = 0;\n\n  for (let i = 0; i < id.length; ++i) {\n    const c = id[i];\n    let characterType;\n    if (c === '-' || c === '_') continue;\n    if (c >= 'a' && c <= 'z') characterType = 'lower';else if (c >= 'A' && c <= 'Z') characterType = 'upper';else if (c >= '0' && c <= '9') characterType = 'digit';else characterType = 'other';\n\n    if (characterType === 'lower' && lastCharacterType === 'upper') {\n      lastCharacterType = characterType;\n      continue;\n    }\n\n    if (lastCharacterType && lastCharacterType !== characterType) ++transitionCount;\n    lastCharacterType = characterType;\n  }\n\n  return transitionCount >= id.length / 4;\n}\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/injected/vueSelectorEngine.ts\":\n/*!***************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/vueSelectorEngine.ts ***!\n  \\***************************************************************************/\n/***/ ((__unused_webpack_module, exports, __webpack_require__) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.VueEngine = void 0;\n\nvar _componentUtils = __webpack_require__(/*! ../common/componentUtils */ \"./packages/playwright-core/src/server/common/componentUtils.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\n// @see https://github.com/vuejs/devtools/blob/14085e25313bcf8ffcb55f9092a40bc0fe3ac11c/packages/shared-utils/src/util.ts#L295\nfunction basename(filename, ext) {\n  const normalized = filename.replace(/^[a-zA-Z]:/, '').replace(/\\\\/g, '/');\n  let result = normalized.substring(normalized.lastIndexOf('/') + 1);\n  if (ext && result.endsWith(ext)) result = result.substring(0, result.length - ext.length);\n  return result;\n} // @see https://github.com/vuejs/devtools/blob/14085e25313bcf8ffcb55f9092a40bc0fe3ac11c/packages/shared-utils/src/util.ts#L41\n\n\nfunction toUpper(_, c) {\n  return c ? c.toUpperCase() : '';\n} // @see https://github.com/vuejs/devtools/blob/14085e25313bcf8ffcb55f9092a40bc0fe3ac11c/packages/shared-utils/src/util.ts#L23\n\n\nconst classifyRE = /(?:^|[-_/])(\\w)/g;\n\nconst classify = str => {\n  return str && str.replace(classifyRE, toUpper);\n};\n\nfunction buildComponentsTreeVue3(instance) {\n  // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/util.ts#L47\n  function getComponentTypeName(options) {\n    const name = options.name || options._componentTag || options.__playwright_guessedName;\n    if (name) return name;\n    const file = options.__file; // injected by vue-loader\n\n    if (file) return classify(basename(file, '.vue'));\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/util.ts#L42\n\n\n  function saveComponentName(instance, key) {\n    instance.type.__playwright_guessedName = key;\n    return key;\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/util.ts#L29\n\n\n  function getInstanceName(instance) {\n    const name = getComponentTypeName(instance.type || {});\n    if (name) return name;\n    if (instance.root === instance) return 'Root';\n\n    for (const key in (_instance$parent = instance.parent) === null || _instance$parent === void 0 ? void 0 : (_instance$parent$type = _instance$parent.type) === null || _instance$parent$type === void 0 ? void 0 : _instance$parent$type.components) {\n      var _instance$parent, _instance$parent$type, _instance$parent2;\n\n      if (((_instance$parent2 = instance.parent) === null || _instance$parent2 === void 0 ? void 0 : _instance$parent2.type.components[key]) === instance.type) return saveComponentName(instance, key);\n    }\n\n    for (const key in (_instance$appContext = instance.appContext) === null || _instance$appContext === void 0 ? void 0 : _instance$appContext.components) {\n      var _instance$appContext;\n\n      if (instance.appContext.components[key] === instance.type) return saveComponentName(instance, key);\n    }\n\n    return 'Anonymous Component';\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/util.ts#L6\n\n\n  function isBeingDestroyed(instance) {\n    return instance._isBeingDestroyed || instance.isUnmounted;\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/util.ts#L16\n\n\n  function isFragment(instance) {\n    return instance.subTree.type.toString() === 'Symbol(Fragment)';\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/tree.ts#L79\n\n\n  function getInternalInstanceChildren(subTree) {\n    const list = [];\n    if (subTree.component) list.push(subTree.component);\n    if (subTree.suspense) list.push(...getInternalInstanceChildren(subTree.suspense.activeBranch));\n\n    if (Array.isArray(subTree.children)) {\n      subTree.children.forEach(childSubTree => {\n        if (childSubTree.component) list.push(childSubTree.component);else list.push(...getInternalInstanceChildren(childSubTree));\n      });\n    }\n\n    return list.filter(child => {\n      var _child$type$devtools;\n\n      return !isBeingDestroyed(child) && !((_child$type$devtools = child.type.devtools) !== null && _child$type$devtools !== void 0 && _child$type$devtools.hide);\n    });\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/el.ts#L8\n\n\n  function getRootElementsFromComponentInstance(instance) {\n    if (isFragment(instance)) return getFragmentRootElements(instance.subTree);\n    return [instance.subTree.el];\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue3/src/components/el.ts#L15\n\n\n  function getFragmentRootElements(vnode) {\n    if (!vnode.children) return [];\n    const list = [];\n\n    for (let i = 0, l = vnode.children.length; i < l; i++) {\n      const childVnode = vnode.children[i];\n      if (childVnode.component) list.push(...getRootElementsFromComponentInstance(childVnode.component));else if (childVnode.el) list.push(childVnode.el);\n    }\n\n    return list;\n  }\n\n  function buildComponentsTree(instance) {\n    return {\n      name: getInstanceName(instance),\n      children: getInternalInstanceChildren(instance.subTree).map(buildComponentsTree),\n      rootElements: getRootElementsFromComponentInstance(instance),\n      props: instance.props\n    };\n  }\n\n  return buildComponentsTree(instance);\n}\n\nfunction buildComponentsTreeVue2(instance) {\n  // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/shared-utils/src/util.ts#L302\n  function getComponentName(options) {\n    const name = options.displayName || options.name || options._componentTag;\n    if (name) return name;\n    const file = options.__file; // injected by vue-loader\n\n    if (file) return classify(basename(file, '.vue'));\n  } // @see https://github.com/vuejs/devtools/blob/e7132f3392b975e39e1d9a23cf30456c270099c2/packages/app-backend-vue2/src/components/util.ts#L10\n\n\n  function getInstanceName(instance) {\n    const name = getComponentName(instance.$options || instance.fnOptions || {});\n    if (name) return name;\n    return instance.$root === instance ? 'Root' : 'Anonymous Component';\n  } // @see https://github.com/vuejs/devtools/blob/14085e25313bcf8ffcb55f9092a40bc0fe3ac11c/packages/app-backend-vue2/src/components/tree.ts#L103\n\n\n  function getInternalInstanceChildren(instance) {\n    if (instance.$children) return instance.$children;\n    if (Array.isArray(instance.subTree.children)) return instance.subTree.children.filter(vnode => !!vnode.component).map(vnode => vnode.component);\n    return [];\n  }\n\n  function buildComponentsTree(instance) {\n    return {\n      name: getInstanceName(instance),\n      children: getInternalInstanceChildren(instance).map(buildComponentsTree),\n      rootElements: [instance.$el],\n      props: instance._props\n    };\n  }\n\n  return buildComponentsTree(instance);\n}\n\nfunction filterComponentsTree(treeNode, searchFn, result = []) {\n  if (searchFn(treeNode)) result.push(treeNode);\n\n  for (const child of treeNode.children) filterComponentsTree(child, searchFn, result);\n\n  return result;\n}\n\nfunction findVueRoots() {\n  const roots = []; // Vue3 roots are marked with [data-v-app] attribute\n\n  for (const node of document.querySelectorAll('[data-v-app]')) {\n    if (node._vnode && node._vnode.component) roots.push({\n      root: node._vnode.component,\n      version: 3\n    });\n  } // Vue2 roots are referred to from elements.\n\n\n  const walker = document.createTreeWalker(document, NodeFilter.SHOW_ELEMENT);\n  const vue2Roots = new Set();\n\n  while (walker.nextNode()) {\n    const element = walker.currentNode;\n    if (element && element.__vue__) vue2Roots.add(element.__vue__.$root);\n  }\n\n  for (const vue2root of vue2Roots) {\n    roots.push({\n      version: 2,\n      root: vue2root\n    });\n  }\n\n  return roots;\n}\n\nconst VueEngine = {\n  queryAll(scope, selector) {\n    const {\n      name,\n      attributes\n    } = (0, _componentUtils.parseComponentSelector)(selector);\n    const vueRoots = findVueRoots();\n    const trees = vueRoots.map(vueRoot => vueRoot.version === 3 ? buildComponentsTreeVue3(vueRoot.root) : buildComponentsTreeVue2(vueRoot.root));\n    const treeNodes = trees.map(tree => filterComponentsTree(tree, treeNode => {\n      if (name && treeNode.name !== name) return false;\n      if (treeNode.rootElements.some(rootElement => !scope.contains(rootElement))) return false;\n\n      for (const attr of attributes) {\n        if (!(0, _componentUtils.checkComponentAttribute)(treeNode.props, attr)) return false;\n      }\n\n      return true;\n    })).flat();\n    const allRootElements = new Set();\n\n    for (const treeNode of treeNodes) {\n      for (const rootElement of treeNode.rootElements) allRootElements.add(rootElement);\n    }\n\n    return [...allRootElements];\n  }\n\n};\nexports.VueEngine = VueEngine;\n\n/***/ }),\n\n/***/ \"./packages/playwright-core/src/server/injected/xpathSelectorEngine.ts\":\n/*!*****************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/xpathSelectorEngine.ts ***!\n  \\*****************************************************************************/\n/***/ ((__unused_webpack_module, exports) => {\n\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports.XPathEngine = void 0;\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nconst XPathEngine = {\n  queryAll(root, selector) {\n    if (selector.startsWith('/')) selector = '.' + selector;\n    const result = [];\n    const document = root instanceof Document ? root : root.ownerDocument;\n    if (!document) return result;\n    const it = document.evaluate(selector, root, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE);\n\n    for (let node = it.iterateNext(); node; node = it.iterateNext()) {\n      if (node.nodeType === Node.ELEMENT_NODE) result.push(node);\n    }\n\n    return result;\n  }\n\n};\nexports.XPathEngine = XPathEngine;\n\n/***/ })\n\n/******/ \t});\n/************************************************************************/\n/******/ \t// The module cache\n/******/ \tvar __webpack_module_cache__ = {};\n/******/ \t\n/******/ \t// The require function\n/******/ \tfunction __webpack_require__(moduleId) {\n/******/ \t\t// Check if module is in cache\n/******/ \t\tvar cachedModule = __webpack_module_cache__[moduleId];\n/******/ \t\tif (cachedModule !== undefined) {\n/******/ \t\t\treturn cachedModule.exports;\n/******/ \t\t}\n/******/ \t\t// Create a new module (and put it into the cache)\n/******/ \t\tvar module = __webpack_module_cache__[moduleId] = {\n/******/ \t\t\t// no module.id needed\n/******/ \t\t\t// no module.loaded needed\n/******/ \t\t\texports: {}\n/******/ \t\t};\n/******/ \t\n/******/ \t\t// Execute the module function\n/******/ \t\t__webpack_modules__[moduleId](module, module.exports, __webpack_require__);\n/******/ \t\n/******/ \t\t// Return the exports of the module\n/******/ \t\treturn module.exports;\n/******/ \t}\n/******/ \t\n/************************************************************************/\n/******/ \t/* webpack/runtime/global */\n/******/ \t(() => {\n/******/ \t\t__webpack_require__.g = (function() {\n/******/ \t\t\tif (typeof globalThis === 'object') return globalThis;\n/******/ \t\t\ttry {\n/******/ \t\t\t\treturn this || new Function('return this')();\n/******/ \t\t\t} catch (e) {\n/******/ \t\t\t\tif (typeof window === 'object') return window;\n/******/ \t\t\t}\n/******/ \t\t})();\n/******/ \t})();\n/******/ \t\n/************************************************************************/\nvar __webpack_exports__ = {};\n// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.\n(() => {\nvar exports = __webpack_exports__;\n/*!************************************************************************!*\\\n  !*** ./packages/playwright-core/src/server/injected/injectedScript.ts ***!\n  \\************************************************************************/\n\n\nObject.defineProperty(exports, \"__esModule\", ({\n  value: true\n}));\nexports[\"default\"] = exports.InjectedScript = void 0;\n\nvar _xpathSelectorEngine = __webpack_require__(/*! ./xpathSelectorEngine */ \"./packages/playwright-core/src/server/injected/xpathSelectorEngine.ts\");\n\nvar _reactSelectorEngine = __webpack_require__(/*! ./reactSelectorEngine */ \"./packages/playwright-core/src/server/injected/reactSelectorEngine.ts\");\n\nvar _vueSelectorEngine = __webpack_require__(/*! ./vueSelectorEngine */ \"./packages/playwright-core/src/server/injected/vueSelectorEngine.ts\");\n\nvar _selectorParser = __webpack_require__(/*! ../common/selectorParser */ \"./packages/playwright-core/src/server/common/selectorParser.ts\");\n\nvar _selectorEvaluator = __webpack_require__(/*! ./selectorEvaluator */ \"./packages/playwright-core/src/server/injected/selectorEvaluator.ts\");\n\nvar _selectorGenerator = __webpack_require__(/*! ./selectorGenerator */ \"./packages/playwright-core/src/server/injected/selectorGenerator.ts\");\n\n/**\n * Copyright (c) Microsoft Corporation.\n *\n * Licensed under the Apache License, Version 2.0 (the \"License\");\n * you may not use this file except in compliance with the License.\n * You may obtain a copy of the License at\n *\n * http://www.apache.org/licenses/LICENSE-2.0\n *\n * Unless required by applicable law or agreed to in writing, software\n * distributed under the License is distributed on an \"AS IS\" BASIS,\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n * See the License for the specific language governing permissions and\n * limitations under the License.\n */\nclass InjectedScript {\n  constructor(stableRafCount, browserName, customEngines) {\n    this._engines = void 0;\n    this._evaluator = void 0;\n    this._stableRafCount = void 0;\n    this._browserName = void 0;\n    this.onGlobalListenersRemoved = new Set();\n    this._hitTargetInterceptor = void 0;\n    this._evaluator = new _selectorEvaluator.SelectorEvaluatorImpl(new Map());\n    this._engines = new Map();\n\n    this._engines.set('xpath', _xpathSelectorEngine.XPathEngine);\n\n    this._engines.set('xpath:light', _xpathSelectorEngine.XPathEngine);\n\n    this._engines.set('_react', _reactSelectorEngine.ReactEngine);\n\n    this._engines.set('_vue', _vueSelectorEngine.VueEngine);\n\n    this._engines.set('text', this._createTextEngine(true));\n\n    this._engines.set('text:light', this._createTextEngine(false));\n\n    this._engines.set('id', this._createAttributeEngine('id', true));\n\n    this._engines.set('id:light', this._createAttributeEngine('id', false));\n\n    this._engines.set('data-testid', this._createAttributeEngine('data-testid', true));\n\n    this._engines.set('data-testid:light', this._createAttributeEngine('data-testid', false));\n\n    this._engines.set('data-test-id', this._createAttributeEngine('data-test-id', true));\n\n    this._engines.set('data-test-id:light', this._createAttributeEngine('data-test-id', false));\n\n    this._engines.set('data-test', this._createAttributeEngine('data-test', true));\n\n    this._engines.set('data-test:light', this._createAttributeEngine('data-test', false));\n\n    this._engines.set('css', this._createCSSEngine());\n\n    this._engines.set('nth', {\n      queryAll: () => []\n    });\n\n    this._engines.set('visible', {\n      queryAll: () => []\n    });\n\n    this._engines.set('control', this._createControlEngine());\n\n    for (const {\n      name,\n      engine\n    } of customEngines) this._engines.set(name, engine);\n\n    this._stableRafCount = stableRafCount;\n    this._browserName = browserName;\n\n    this._setupGlobalListenersRemovalDetection();\n\n    this._setupHitTargetInterceptors();\n  }\n\n  eval(expression) {\n    return __webpack_require__.g.eval(expression);\n  }\n\n  parseSelector(selector) {\n    const result = (0, _selectorParser.parseSelector)(selector);\n\n    for (const part of result.parts) {\n      if (!this._engines.has(part.name)) throw this.createStacklessError(`Unknown engine \"${part.name}\" while parsing selector ${selector}`);\n    }\n\n    return result;\n  }\n\n  querySelector(selector, root, strict) {\n    if (!root['querySelector']) throw this.createStacklessError('Node is not queryable.');\n\n    this._evaluator.begin();\n\n    try {\n      var _result$, _result$2;\n\n      const result = this._querySelectorRecursively([{\n        element: root,\n        capture: undefined\n      }], selector, 0, new Map());\n\n      if (strict && result.length > 1) throw this.strictModeViolationError(selector, result.map(r => r.element));\n      return ((_result$ = result[0]) === null || _result$ === void 0 ? void 0 : _result$.capture) || ((_result$2 = result[0]) === null || _result$2 === void 0 ? void 0 : _result$2.element);\n    } finally {\n      this._evaluator.end();\n    }\n  }\n\n  _querySelectorRecursively(roots, selector, index, queryCache) {\n    if (index === selector.parts.length) return roots;\n    const part = selector.parts[index];\n\n    if (part.name === 'nth') {\n      let filtered = [];\n\n      if (part.body === '0') {\n        filtered = roots.slice(0, 1);\n      } else if (part.body === '-1') {\n        if (roots.length) filtered = roots.slice(roots.length - 1);\n      } else {\n        if (typeof selector.capture === 'number') throw this.createStacklessError(`Can't query n-th element in a request with the capture.`);\n        const nth = +part.body;\n        const set = new Set();\n\n        for (const root of roots) {\n          set.add(root.element);\n          if (nth + 1 === set.size) filtered = [root];\n        }\n      }\n\n      return this._querySelectorRecursively(filtered, selector, index + 1, queryCache);\n    }\n\n    if (part.name === 'visible') {\n      const visible = Boolean(part.body);\n      const filtered = roots.filter(match => visible === (0, _selectorEvaluator.isVisible)(match.element));\n      return this._querySelectorRecursively(filtered, selector, index + 1, queryCache);\n    }\n\n    const result = [];\n\n    for (const root of roots) {\n      const capture = index - 1 === selector.capture ? root.element : root.capture; // Do not query engine twice for the same element.\n\n      let queryResults = queryCache.get(root.element);\n\n      if (!queryResults) {\n        queryResults = [];\n        queryCache.set(root.element, queryResults);\n      }\n\n      let all = queryResults[index];\n\n      if (!all) {\n        all = this._queryEngineAll(selector.parts[index], root.element);\n        queryResults[index] = all;\n      }\n\n      for (const element of all) {\n        if (!('nodeName' in element)) throw this.createStacklessError(`Expected a Node but got ${Object.prototype.toString.call(element)}`);\n        result.push({\n          element,\n          capture\n        });\n      }\n    }\n\n    return this._querySelectorRecursively(result, selector, index + 1, queryCache);\n  }\n\n  querySelectorAll(selector, root) {\n    if (!root['querySelectorAll']) throw this.createStacklessError('Node is not queryable.');\n\n    this._evaluator.begin();\n\n    try {\n      const result = this._querySelectorRecursively([{\n        element: root,\n        capture: undefined\n      }], selector, 0, new Map());\n\n      const set = new Set();\n\n      for (const r of result) set.add(r.capture || r.element);\n\n      return [...set];\n    } finally {\n      this._evaluator.end();\n    }\n  }\n\n  _queryEngineAll(part, root) {\n    return this._engines.get(part.name).queryAll(root, part.body);\n  }\n\n  _createAttributeEngine(attribute, shadow) {\n    const toCSS = selector => {\n      const css = `[${attribute}=${JSON.stringify(selector)}]`;\n      return [{\n        simples: [{\n          selector: {\n            css,\n            functions: []\n          },\n          combinator: ''\n        }]\n      }];\n    };\n\n    return {\n      queryAll: (root, selector) => {\n        return this._evaluator.query({\n          scope: root,\n          pierceShadow: shadow\n        }, toCSS(selector));\n      }\n    };\n  }\n\n  _createCSSEngine() {\n    const evaluator = this._evaluator;\n    return {\n      queryAll(root, body) {\n        return evaluator.query({\n          scope: root,\n          pierceShadow: true\n        }, body);\n      }\n\n    };\n  }\n\n  _createTextEngine(shadow) {\n    const queryList = (root, selector) => {\n      const {\n        matcher,\n        kind\n      } = createTextMatcher(selector);\n      const result = [];\n      let lastDidNotMatchSelf = null;\n\n      const appendElement = element => {\n        // TODO: replace contains() with something shadow-dom-aware?\n        if (kind === 'lax' && lastDidNotMatchSelf && lastDidNotMatchSelf.contains(element)) return false;\n        const matches = (0, _selectorEvaluator.elementMatchesText)(this._evaluator, element, matcher);\n        if (matches === 'none') lastDidNotMatchSelf = element;\n        if (matches === 'self' || matches === 'selfAndChildren' && kind === 'strict') result.push(element);\n      };\n\n      if (root.nodeType === Node.ELEMENT_NODE) appendElement(root);\n\n      const elements = this._evaluator._queryCSS({\n        scope: root,\n        pierceShadow: shadow\n      }, '*');\n\n      for (const element of elements) appendElement(element);\n\n      return result;\n    };\n\n    return {\n      queryAll: (root, selector) => {\n        return queryList(root, selector);\n      }\n    };\n  }\n\n  _createControlEngine() {\n    return {\n      queryAll(root, body) {\n        if (body === 'enter-frame') return [];\n        if (body === 'return-empty') return [];\n        throw new Error(`Internal error, unknown control selector ${body}`);\n      }\n\n    };\n  }\n\n  extend(source, params) {\n    const constrFunction = __webpack_require__.g.eval(`\n    (() => {\n      ${source}\n      return pwExport;\n    })()`);\n    return new constrFunction(this, params);\n  }\n\n  isVisible(element) {\n    return (0, _selectorEvaluator.isVisible)(element);\n  }\n\n  pollRaf(predicate) {\n    return this.poll(predicate, next => requestAnimationFrame(next));\n  }\n\n  pollInterval(pollInterval, predicate) {\n    return this.poll(predicate, next => setTimeout(next, pollInterval));\n  }\n\n  pollLogScale(predicate) {\n    const pollIntervals = [100, 250, 500];\n    let attempts = 0;\n    return this.poll(predicate, next => setTimeout(next, pollIntervals[attempts++] || 1000));\n  }\n\n  poll(predicate, scheduleNext) {\n    return this._runAbortableTask(progress => {\n      let fulfill;\n      let reject;\n      const result = new Promise((f, r) => {\n        fulfill = f;\n        reject = r;\n      });\n\n      const next = () => {\n        if (progress.aborted) return;\n\n        try {\n          const success = predicate(progress);\n          if (success !== progress.continuePolling) fulfill(success);else scheduleNext(next);\n        } catch (e) {\n          progress.log('  ' + e.message);\n          reject(e);\n        }\n      };\n\n      next();\n      return result;\n    });\n  }\n\n  _runAbortableTask(task) {\n    let unsentLog = [];\n    let takeNextLogsCallback;\n    let taskFinished = false;\n\n    const logReady = () => {\n      if (!takeNextLogsCallback) return;\n      takeNextLogsCallback(unsentLog);\n      unsentLog = [];\n      takeNextLogsCallback = undefined;\n    };\n\n    const takeNextLogs = () => new Promise(fulfill => {\n      takeNextLogsCallback = fulfill;\n      if (unsentLog.length || taskFinished) logReady();\n    });\n\n    let lastMessage = '';\n    let lastIntermediateResult = undefined;\n    const progress = {\n      injectedScript: this,\n      aborted: false,\n      continuePolling: Symbol('continuePolling'),\n      log: message => {\n        lastMessage = message;\n        unsentLog.push({\n          message\n        });\n        logReady();\n      },\n      logRepeating: message => {\n        if (message !== lastMessage) progress.log(message);\n      },\n      setIntermediateResult: intermediateResult => {\n        if (lastIntermediateResult === intermediateResult) return;\n        lastIntermediateResult = intermediateResult;\n        unsentLog.push({\n          intermediateResult\n        });\n        logReady();\n      }\n    };\n\n    const run = () => {\n      const result = task(progress); // After the task has finished, there should be no more logs.\n      // Release any pending `takeNextLogs` call, and do not block any future ones.\n      // This prevents non-finished protocol evaluation calls and memory leaks.\n\n      result.finally(() => {\n        taskFinished = true;\n        logReady();\n      });\n      return result;\n    };\n\n    return {\n      takeNextLogs,\n      run,\n      cancel: () => {\n        progress.aborted = true;\n      },\n      takeLastLogs: () => unsentLog\n    };\n  }\n\n  getElementBorderWidth(node) {\n    if (node.nodeType !== Node.ELEMENT_NODE || !node.ownerDocument || !node.ownerDocument.defaultView) return {\n      left: 0,\n      top: 0\n    };\n    const style = node.ownerDocument.defaultView.getComputedStyle(node);\n    return {\n      left: parseInt(style.borderLeftWidth || '', 10),\n      top: parseInt(style.borderTopWidth || '', 10)\n    };\n  }\n\n  retarget(node, behavior) {\n    let element = node.nodeType === Node.ELEMENT_NODE ? node : node.parentElement;\n    if (!element) return null;\n    if (!element.matches('input, textarea, select')) element = element.closest('button, [role=button], [role=checkbox], [role=radio]') || element;\n\n    if (behavior === 'follow-label') {\n      if (!element.matches('input, textarea, button, select, [role=button], [role=checkbox], [role=radio]') && !element.isContentEditable) {\n        // Go up to the label that might be connected to the input/textarea.\n        element = element.closest('label') || element;\n      }\n\n      if (element.nodeName === 'LABEL') element = element.control || element;\n    }\n\n    return element;\n  }\n\n  waitForElementStatesAndPerformAction(node, states, force, callback) {\n    let lastRect;\n    let counter = 0;\n    let samePositionCounter = 0;\n    let lastTime = 0;\n    return this.pollRaf(progress => {\n      if (force) {\n        progress.log(`    forcing action`);\n        return callback(node, progress);\n      }\n\n      for (const state of states) {\n        if (state !== 'stable') {\n          const result = this.elementState(node, state);\n          if (typeof result !== 'boolean') return result;\n\n          if (!result) {\n            progress.logRepeating(`    element is not ${state} - waiting...`);\n            return progress.continuePolling;\n          }\n\n          continue;\n        }\n\n        const element = this.retarget(node, 'no-follow-label');\n        if (!element) return 'error:notconnected'; // First raf happens in the same animation frame as evaluation, so it does not produce\n        // any client rect difference compared to synchronous call. We skip the synchronous call\n        // and only force layout during actual rafs as a small optimisation.\n\n        if (++counter === 1) return progress.continuePolling; // Drop frames that are shorter than 16ms - WebKit Win bug.\n\n        const time = performance.now();\n        if (this._stableRafCount > 1 && time - lastTime < 15) return progress.continuePolling;\n        lastTime = time;\n        const clientRect = element.getBoundingClientRect();\n        const rect = {\n          x: clientRect.top,\n          y: clientRect.left,\n          width: clientRect.width,\n          height: clientRect.height\n        };\n        const samePosition = lastRect && rect.x === lastRect.x && rect.y === lastRect.y && rect.width === lastRect.width && rect.height === lastRect.height;\n        if (samePosition) ++samePositionCounter;else samePositionCounter = 0;\n        const isStable = samePositionCounter >= this._stableRafCount;\n        const isStableForLogs = isStable || !lastRect;\n        lastRect = rect;\n        if (!isStableForLogs) progress.logRepeating(`    element is not stable - waiting...`);\n        if (!isStable) return progress.continuePolling;\n      }\n\n      return callback(node, progress);\n    });\n  }\n\n  elementState(node, state) {\n    const element = this.retarget(node, ['stable', 'visible', 'hidden'].includes(state) ? 'no-follow-label' : 'follow-label');\n\n    if (!element || !element.isConnected) {\n      if (state === 'hidden') return true;\n      return 'error:notconnected';\n    }\n\n    if (state === 'visible') return this.isVisible(element);\n    if (state === 'hidden') return !this.isVisible(element);\n    const disabled = isElementDisabled(element);\n    if (state === 'disabled') return disabled;\n    if (state === 'enabled') return !disabled;\n    const editable = !(['INPUT', 'TEXTAREA', 'SELECT'].includes(element.nodeName) && element.hasAttribute('readonly'));\n    if (state === 'editable') return !disabled && editable;\n\n    if (state === 'checked') {\n      if (['checkbox', 'radio'].includes(element.getAttribute('role') || '')) return element.getAttribute('aria-checked') === 'true';\n      if (element.nodeName !== 'INPUT') throw this.createStacklessError('Not a checkbox or radio button');\n      if (!['radio', 'checkbox'].includes(element.type.toLowerCase())) throw this.createStacklessError('Not a checkbox or radio button');\n      return element.checked;\n    }\n\n    throw this.createStacklessError(`Unexpected element state \"${state}\"`);\n  }\n\n  selectOptions(optionsToSelect, node, progress) {\n    const element = this.retarget(node, 'follow-label');\n    if (!element) return 'error:notconnected';\n    if (element.nodeName.toLowerCase() !== 'select') throw this.createStacklessError('Element is not a <select> element');\n    const select = element;\n    const options = [...select.options];\n    const selectedOptions = [];\n    let remainingOptionsToSelect = optionsToSelect.slice();\n\n    for (let index = 0; index < options.length; index++) {\n      const option = options[index];\n\n      const filter = optionToSelect => {\n        if (optionToSelect instanceof Node) return option === optionToSelect;\n        let matches = true;\n        if (optionToSelect.value !== undefined) matches = matches && optionToSelect.value === option.value;\n        if (optionToSelect.label !== undefined) matches = matches && optionToSelect.label === option.label;\n        if (optionToSelect.index !== undefined) matches = matches && optionToSelect.index === index;\n        return matches;\n      };\n\n      if (!remainingOptionsToSelect.some(filter)) continue;\n      selectedOptions.push(option);\n\n      if (select.multiple) {\n        remainingOptionsToSelect = remainingOptionsToSelect.filter(o => !filter(o));\n      } else {\n        remainingOptionsToSelect = [];\n        break;\n      }\n    }\n\n    if (remainingOptionsToSelect.length) {\n      progress.logRepeating('    did not find some options - waiting... ');\n      return progress.continuePolling;\n    }\n\n    select.value = undefined;\n    selectedOptions.forEach(option => option.selected = true);\n    progress.log('    selected specified option(s)');\n    select.dispatchEvent(new Event('input', {\n      'bubbles': true\n    }));\n    select.dispatchEvent(new Event('change', {\n      'bubbles': true\n    }));\n    return selectedOptions.map(option => option.value);\n  }\n\n  fill(value, node, progress) {\n    const element = this.retarget(node, 'follow-label');\n    if (!element) return 'error:notconnected';\n\n    if (element.nodeName.toLowerCase() === 'input') {\n      const input = element;\n      const type = input.type.toLowerCase();\n      const kDateTypes = new Set(['date', 'time', 'datetime', 'datetime-local', 'month', 'week']);\n      const kTextInputTypes = new Set(['', 'email', 'number', 'password', 'search', 'tel', 'text', 'url']);\n\n      if (!kTextInputTypes.has(type) && !kDateTypes.has(type)) {\n        progress.log(`    input of type \"${type}\" cannot be filled`);\n        throw this.createStacklessError(`Input of type \"${type}\" cannot be filled`);\n      }\n\n      if (type === 'number') {\n        value = value.trim();\n        if (isNaN(Number(value))) throw this.createStacklessError('Cannot type text into input[type=number]');\n      }\n\n      if (kDateTypes.has(type)) {\n        value = value.trim();\n        input.focus();\n        input.value = value;\n        if (input.value !== value) throw this.createStacklessError('Malformed value');\n        element.dispatchEvent(new Event('input', {\n          'bubbles': true\n        }));\n        element.dispatchEvent(new Event('change', {\n          'bubbles': true\n        }));\n        return 'done'; // We have already changed the value, no need to input it.\n      }\n    } else if (element.nodeName.toLowerCase() === 'textarea') {// Nothing to check here.\n    } else if (!element.isContentEditable) {\n      throw this.createStacklessError('Element is not an <input>, <textarea> or [contenteditable] element');\n    }\n\n    this.selectText(element);\n    return 'needsinput'; // Still need to input the value.\n  }\n\n  selectText(node) {\n    const element = this.retarget(node, 'follow-label');\n    if (!element) return 'error:notconnected';\n\n    if (element.nodeName.toLowerCase() === 'input') {\n      const input = element;\n      input.select();\n      input.focus();\n      return 'done';\n    }\n\n    if (element.nodeName.toLowerCase() === 'textarea') {\n      const textarea = element;\n      textarea.selectionStart = 0;\n      textarea.selectionEnd = textarea.value.length;\n      textarea.focus();\n      return 'done';\n    }\n\n    const range = element.ownerDocument.createRange();\n    range.selectNodeContents(element);\n    const selection = element.ownerDocument.defaultView.getSelection();\n\n    if (selection) {\n      selection.removeAllRanges();\n      selection.addRange(range);\n    }\n\n    element.focus();\n    return 'done';\n  }\n\n  focusNode(node, resetSelectionIfNotFocused) {\n    if (!node.isConnected) return 'error:notconnected';\n    if (node.nodeType !== Node.ELEMENT_NODE) throw this.createStacklessError('Node is not an element');\n    const wasFocused = node.getRootNode().activeElement === node && node.ownerDocument && node.ownerDocument.hasFocus();\n    node.focus();\n\n    if (resetSelectionIfNotFocused && !wasFocused && node.nodeName.toLowerCase() === 'input') {\n      try {\n        const input = node;\n        input.setSelectionRange(0, 0);\n      } catch (e) {// Some inputs do not allow selection.\n      }\n    }\n\n    return 'done';\n  }\n\n  setInputFiles(node, payloads) {\n    if (node.nodeType !== Node.ELEMENT_NODE) return 'Node is not of type HTMLElement';\n    const element = node;\n    if (element.nodeName !== 'INPUT') return 'Not an <input> element';\n    const input = element;\n    const type = (input.getAttribute('type') || '').toLowerCase();\n    if (type !== 'file') return 'Not an input[type=file] element';\n    const files = payloads.map(file => {\n      const bytes = Uint8Array.from(atob(file.buffer), c => c.charCodeAt(0));\n      return new File([bytes], file.name, {\n        type: file.mimeType\n      });\n    });\n    const dt = new DataTransfer();\n\n    for (const file of files) dt.items.add(file);\n\n    input.files = dt.files;\n    input.dispatchEvent(new Event('input', {\n      'bubbles': true\n    }));\n    input.dispatchEvent(new Event('change', {\n      'bubbles': true\n    }));\n  }\n\n  checkHitTargetAt(node, point) {\n    let element = node.nodeType === Node.ELEMENT_NODE ? node : node.parentElement;\n    if (!element || !element.isConnected) return 'error:notconnected';\n    element = element.closest('button, [role=button]') || element;\n    const hitElement = this.deepElementFromPoint(document, point.x, point.y);\n    return this._expectHitTargetParent(hitElement, element);\n  }\n\n  _expectHitTargetParent(hitElement, targetElement) {\n    const hitParents = [];\n\n    while (hitElement && hitElement !== targetElement) {\n      hitParents.push(hitElement);\n      hitElement = (0, _selectorEvaluator.parentElementOrShadowHost)(hitElement);\n    }\n\n    if (hitElement === targetElement) return 'done';\n    const hitTargetDescription = this.previewNode(hitParents[0] || document.documentElement); // Root is the topmost element in the hitTarget's chain that is not in the\n    // element's chain. For example, it might be a dialog element that overlays\n    // the target.\n\n    let rootHitTargetDescription;\n    let element = targetElement;\n\n    while (element) {\n      const index = hitParents.indexOf(element);\n\n      if (index !== -1) {\n        if (index > 1) rootHitTargetDescription = this.previewNode(hitParents[index - 1]);\n        break;\n      }\n\n      element = (0, _selectorEvaluator.parentElementOrShadowHost)(element);\n    }\n\n    if (rootHitTargetDescription) return {\n      hitTargetDescription: `${hitTargetDescription} from ${rootHitTargetDescription} subtree`\n    };\n    return {\n      hitTargetDescription\n    };\n  }\n\n  setupHitTargetInterceptor(node, action, blockAllEvents) {\n    const maybeElement = node.nodeType === Node.ELEMENT_NODE ? node : node.parentElement;\n    if (!maybeElement || !maybeElement.isConnected) return 'error:notconnected';\n    const element = maybeElement.closest('button, [role=button]') || maybeElement;\n    const events = {\n      'hover': kHoverHitTargetInterceptorEvents,\n      'tap': kTapHitTargetInterceptorEvents,\n      'mouse': kMouseHitTargetInterceptorEvents\n    }[action];\n    let result;\n\n    const listener = event => {\n      // Ignore events that we do not expect to intercept.\n      if (!events.has(event.type)) return; // Playwright only issues trusted events, so allow any custom events originating from\n      // the page or content scripts.\n\n      if (!event.isTrusted) return; // Element was detached during the action, for example in some event handler.\n      // If events before that were correctly pointing to it, consider this a valid scenario.\n\n      if (!element.isConnected) return; // Determine the event point. Note that Firefox does not always have window.TouchEvent.\n\n      const point = !!window.TouchEvent && event instanceof window.TouchEvent ? event.touches[0] : event;\n\n      if (!!point && (result === undefined || result === 'done')) {\n        // Determine whether we hit the target element, unless we have already failed.\n        const hitElement = this.deepElementFromPoint(document, point.clientX, point.clientY);\n        result = this._expectHitTargetParent(hitElement, element);\n      }\n\n      if (blockAllEvents || result !== 'done') {\n        event.preventDefault();\n        event.stopPropagation();\n        event.stopImmediatePropagation();\n      }\n    };\n\n    const stop = () => {\n      if (this._hitTargetInterceptor === listener) this._hitTargetInterceptor = undefined; // If we did not get any events, consider things working. Possible causes:\n      // - JavaScript is disabled (webkit-only).\n      // - Some <iframe> overlays the element from another frame.\n      // - Hovering a disabled control prevents any events from firing.\n\n      return result || 'done';\n    }; // Note: this removes previous listener, just in case there are two concurrent clicks\n    // or something went wrong and we did not cleanup.\n\n\n    this._hitTargetInterceptor = listener;\n    return {\n      stop\n    };\n  }\n\n  dispatchEvent(node, type, eventInit) {\n    let event;\n    eventInit = {\n      bubbles: true,\n      cancelable: true,\n      composed: true,\n      ...eventInit\n    };\n\n    switch (eventType.get(type)) {\n      case 'mouse':\n        event = new MouseEvent(type, eventInit);\n        break;\n\n      case 'keyboard':\n        event = new KeyboardEvent(type, eventInit);\n        break;\n\n      case 'touch':\n        event = new TouchEvent(type, eventInit);\n        break;\n\n      case 'pointer':\n        event = new PointerEvent(type, eventInit);\n        break;\n\n      case 'focus':\n        event = new FocusEvent(type, eventInit);\n        break;\n\n      case 'drag':\n        event = new DragEvent(type, eventInit);\n        break;\n\n      default:\n        event = new Event(type, eventInit);\n        break;\n    }\n\n    node.dispatchEvent(event);\n  }\n\n  deepElementFromPoint(document, x, y) {\n    let container = document;\n    let element;\n\n    while (container) {\n      // elementFromPoint works incorrectly in Chromium (http://crbug.com/1188919),\n      // so we use elementsFromPoint instead.\n      const elements = container.elementsFromPoint(x, y);\n      const innerElement = elements[0];\n      if (!innerElement || element === innerElement) break;\n      element = innerElement;\n      container = element.shadowRoot;\n    }\n\n    return element;\n  }\n\n  previewNode(node) {\n    if (node.nodeType === Node.TEXT_NODE) return oneLine(`#text=${node.nodeValue || ''}`);\n    if (node.nodeType !== Node.ELEMENT_NODE) return oneLine(`<${node.nodeName.toLowerCase()} />`);\n    const element = node;\n    const attrs = [];\n\n    for (let i = 0; i < element.attributes.length; i++) {\n      const {\n        name,\n        value\n      } = element.attributes[i];\n      if (name === 'style' || name.startsWith('__playwright')) continue;\n      if (!value && booleanAttributes.has(name)) attrs.push(` ${name}`);else attrs.push(` ${name}=\"${value}\"`);\n    }\n\n    attrs.sort((a, b) => a.length - b.length);\n    let attrText = attrs.join('');\n    if (attrText.length > 50) attrText = attrText.substring(0, 49) + '\\u2026';\n    if (autoClosingTags.has(element.nodeName)) return oneLine(`<${element.nodeName.toLowerCase()}${attrText}/>`);\n    const children = element.childNodes;\n    let onlyText = false;\n\n    if (children.length <= 5) {\n      onlyText = true;\n\n      for (let i = 0; i < children.length; i++) onlyText = onlyText && children[i].nodeType === Node.TEXT_NODE;\n    }\n\n    let text = onlyText ? element.textContent || '' : children.length ? '\\u2026' : '';\n    if (text.length > 50) text = text.substring(0, 49) + '\\u2026';\n    return oneLine(`<${element.nodeName.toLowerCase()}${attrText}>${text}</${element.nodeName.toLowerCase()}>`);\n  }\n\n  strictModeViolationError(selector, matches) {\n    const infos = matches.slice(0, 10).map(m => ({\n      preview: this.previewNode(m),\n      selector: (0, _selectorGenerator.generateSelector)(this, m).selector\n    }));\n    const lines = infos.map((info, i) => `\\n    ${i + 1}) ${info.preview} aka playwright.$(\"${info.selector}\")`);\n    if (infos.length < matches.length) lines.push('\\n    ...');\n    return this.createStacklessError(`strict mode violation: \"${(0, _selectorParser.stringifySelector)(selector)}\" resolved to ${matches.length} elements:${lines.join('')}\\n`);\n  }\n\n  createStacklessError(message) {\n    if (this._browserName === 'firefox') {\n      const error = new Error('Error: ' + message); // Firefox cannot delete the stack, so assign to an empty string.\n\n      error.stack = '';\n      return error;\n    }\n\n    const error = new Error(message); // Chromium/WebKit should delete the stack instead.\n\n    delete error.stack;\n    return error;\n  }\n\n  _setupGlobalListenersRemovalDetection() {\n    const customEventName = '__playwright_global_listeners_check__';\n    let seenEvent = false;\n\n    const handleCustomEvent = () => seenEvent = true;\n\n    window.addEventListener(customEventName, handleCustomEvent);\n    new MutationObserver(entries => {\n      const newDocumentElement = entries.some(entry => Array.from(entry.addedNodes).includes(document.documentElement));\n      if (!newDocumentElement) return; // New documentElement - let's check whether listeners are still here.\n\n      seenEvent = false;\n      window.dispatchEvent(new CustomEvent(customEventName));\n      if (seenEvent) return; // Listener did not fire. Reattach the listener and notify.\n\n      window.addEventListener(customEventName, handleCustomEvent);\n\n      for (const callback of this.onGlobalListenersRemoved) callback();\n    }).observe(document, {\n      childList: true\n    });\n  }\n\n  _setupHitTargetInterceptors() {\n    const listener = event => {\n      var _this$_hitTargetInter;\n\n      return (_this$_hitTargetInter = this._hitTargetInterceptor) === null || _this$_hitTargetInter === void 0 ? void 0 : _this$_hitTargetInter.call(this, event);\n    };\n\n    const addHitTargetInterceptorListeners = () => {\n      for (const event of kAllHitTargetInterceptorEvents) window.addEventListener(event, listener, {\n        capture: true,\n        passive: false\n      });\n    };\n\n    addHitTargetInterceptorListeners();\n    this.onGlobalListenersRemoved.add(addHitTargetInterceptorListeners);\n  }\n\n  expectSingleElement(progress, element, options) {\n    const injected = progress.injectedScript;\n    const expression = options.expression;\n    {\n      // Element state / boolean values.\n      let elementState;\n\n      if (expression === 'to.be.checked') {\n        elementState = progress.injectedScript.elementState(element, 'checked');\n      } else if (expression === 'to.be.disabled') {\n        elementState = progress.injectedScript.elementState(element, 'disabled');\n      } else if (expression === 'to.be.editable') {\n        elementState = progress.injectedScript.elementState(element, 'editable');\n      } else if (expression === 'to.be.empty') {\n        var _element$textContent;\n\n        if (element.nodeName === 'INPUT' || element.nodeName === 'TEXTAREA') elementState = !element.value;else elementState = !((_element$textContent = element.textContent) !== null && _element$textContent !== void 0 && _element$textContent.trim());\n      } else if (expression === 'to.be.enabled') {\n        elementState = progress.injectedScript.elementState(element, 'enabled');\n      } else if (expression === 'to.be.focused') {\n        elementState = document.activeElement === element;\n      } else if (expression === 'to.be.hidden') {\n        elementState = progress.injectedScript.elementState(element, 'hidden');\n      } else if (expression === 'to.be.visible') {\n        elementState = progress.injectedScript.elementState(element, 'visible');\n      }\n\n      if (elementState !== undefined) {\n        if (elementState === 'error:notcheckbox') throw injected.createStacklessError('Element is not a checkbox');\n        if (elementState === 'error:notconnected') throw injected.createStacklessError('Element is not connected');\n        return {\n          received: elementState,\n          matches: elementState\n        };\n      }\n    }\n    {\n      // JS property\n      if (expression === 'to.have.property') {\n        const received = element[options.expressionArg];\n        const matches = deepEquals(received, options.expectedValue);\n        return {\n          received,\n          matches\n        };\n      }\n    }\n    {\n      // Single text value.\n      let received;\n\n      if (expression === 'to.have.attribute') {\n        received = element.getAttribute(options.expressionArg) || '';\n      } else if (expression === 'to.have.class') {\n        received = element.className;\n      } else if (expression === 'to.have.css') {\n        received = window.getComputedStyle(element)[options.expressionArg];\n      } else if (expression === 'to.have.id') {\n        received = element.id;\n      } else if (expression === 'to.have.text') {\n        received = options.useInnerText ? element.innerText : element.textContent || '';\n      } else if (expression === 'to.have.title') {\n        received = document.title;\n      } else if (expression === 'to.have.url') {\n        received = document.location.href;\n      } else if (expression === 'to.have.value') {\n        if (element.nodeName !== 'INPUT' && element.nodeName !== 'TEXTAREA' && element.nodeName !== 'SELECT') throw this.createStacklessError('Not an input element');\n        received = element.value;\n      }\n\n      if (received !== undefined && options.expectedText) {\n        const matcher = new ExpectedTextMatcher(options.expectedText[0]);\n        return {\n          received,\n          matches: matcher.matches(received)\n        };\n      }\n    }\n    throw this.createStacklessError('Unknown expect matcher: ' + expression);\n  }\n\n  expectArray(elements, options) {\n    const expression = options.expression;\n\n    if (expression === 'to.have.count') {\n      const received = elements.length;\n      const matches = received === options.expectedNumber;\n      return {\n        received,\n        matches\n      };\n    } // List of values.\n\n\n    let received;\n    if (expression === 'to.have.text.array' || expression === 'to.contain.text.array') received = elements.map(e => options.useInnerText ? e.innerText : e.textContent || '');else if (expression === 'to.have.class.array') received = elements.map(e => e.className);\n\n    if (received && options.expectedText) {\n      // \"To match an array\" is \"to contain an array\" + \"equal length\"\n      const lengthShouldMatch = expression !== 'to.contain.text.array';\n      const matchesLength = received.length === options.expectedText.length || !lengthShouldMatch;\n      if (!matchesLength) return {\n        received,\n        matches: false\n      }; // Each matcher should get a \"received\" that matches it, in order.\n\n      let i = 0;\n      const matchers = options.expectedText.map(e => new ExpectedTextMatcher(e));\n      let allMatchesFound = true;\n\n      for (const matcher of matchers) {\n        while (i < received.length && !matcher.matches(received[i])) i++;\n\n        if (i >= received.length) {\n          allMatchesFound = false;\n          break;\n        }\n      }\n\n      return {\n        received,\n        matches: allMatchesFound\n      };\n    }\n\n    throw this.createStacklessError('Unknown expect matcher: ' + expression);\n  }\n\n}\n\nexports.InjectedScript = InjectedScript;\nconst autoClosingTags = new Set(['AREA', 'BASE', 'BR', 'COL', 'COMMAND', 'EMBED', 'HR', 'IMG', 'INPUT', 'KEYGEN', 'LINK', 'MENUITEM', 'META', 'PARAM', 'SOURCE', 'TRACK', 'WBR']);\nconst booleanAttributes = new Set(['checked', 'selected', 'disabled', 'readonly', 'multiple']);\n\nfunction oneLine(s) {\n  return s.replace(/\\n/g, '↵').replace(/\\t/g, '⇆');\n}\n\nconst eventType = new Map([['auxclick', 'mouse'], ['click', 'mouse'], ['dblclick', 'mouse'], ['mousedown', 'mouse'], ['mouseeenter', 'mouse'], ['mouseleave', 'mouse'], ['mousemove', 'mouse'], ['mouseout', 'mouse'], ['mouseover', 'mouse'], ['mouseup', 'mouse'], ['mouseleave', 'mouse'], ['mousewheel', 'mouse'], ['keydown', 'keyboard'], ['keyup', 'keyboard'], ['keypress', 'keyboard'], ['textInput', 'keyboard'], ['touchstart', 'touch'], ['touchmove', 'touch'], ['touchend', 'touch'], ['touchcancel', 'touch'], ['pointerover', 'pointer'], ['pointerout', 'pointer'], ['pointerenter', 'pointer'], ['pointerleave', 'pointer'], ['pointerdown', 'pointer'], ['pointerup', 'pointer'], ['pointermove', 'pointer'], ['pointercancel', 'pointer'], ['gotpointercapture', 'pointer'], ['lostpointercapture', 'pointer'], ['focus', 'focus'], ['blur', 'focus'], ['drag', 'drag'], ['dragstart', 'drag'], ['dragend', 'drag'], ['dragover', 'drag'], ['dragenter', 'drag'], ['dragleave', 'drag'], ['dragexit', 'drag'], ['drop', 'drag']]);\nconst kHoverHitTargetInterceptorEvents = new Set(['mousemove']);\nconst kTapHitTargetInterceptorEvents = new Set(['pointerdown', 'pointerup', 'touchstart', 'touchend', 'touchcancel']);\nconst kMouseHitTargetInterceptorEvents = new Set(['mousedown', 'mouseup', 'pointerdown', 'pointerup', 'click', 'auxclick', 'dblclick', 'contextmenu']);\nconst kAllHitTargetInterceptorEvents = new Set([...kHoverHitTargetInterceptorEvents, ...kTapHitTargetInterceptorEvents, ...kMouseHitTargetInterceptorEvents]);\n\nfunction unescape(s) {\n  if (!s.includes('\\\\')) return s;\n  const r = [];\n  let i = 0;\n\n  while (i < s.length) {\n    if (s[i] === '\\\\' && i + 1 < s.length) i++;\n    r.push(s[i++]);\n  }\n\n  return r.join('');\n}\n\nfunction createTextMatcher(selector) {\n  if (selector[0] === '/' && selector.lastIndexOf('/') > 0) {\n    const lastSlash = selector.lastIndexOf('/');\n    const matcher = (0, _selectorEvaluator.createRegexTextMatcher)(selector.substring(1, lastSlash), selector.substring(lastSlash + 1));\n    return {\n      matcher,\n      kind: 'regex'\n    };\n  }\n\n  let strict = false;\n\n  if (selector.length > 1 && selector[0] === '\"' && selector[selector.length - 1] === '\"') {\n    selector = unescape(selector.substring(1, selector.length - 1));\n    strict = true;\n  }\n\n  if (selector.length > 1 && selector[0] === \"'\" && selector[selector.length - 1] === \"'\") {\n    selector = unescape(selector.substring(1, selector.length - 1));\n    strict = true;\n  }\n\n  const matcher = strict ? (0, _selectorEvaluator.createStrictTextMatcher)(selector) : (0, _selectorEvaluator.createLaxTextMatcher)(selector);\n  return {\n    matcher,\n    kind: strict ? 'strict' : 'lax'\n  };\n}\n\nclass ExpectedTextMatcher {\n  constructor(expected) {\n    this._string = void 0;\n    this._substring = void 0;\n    this._regex = void 0;\n    this._normalizeWhiteSpace = void 0;\n    this._normalizeWhiteSpace = expected.normalizeWhiteSpace;\n    this._string = expected.matchSubstring ? undefined : this.normalizeWhiteSpace(expected.string);\n    this._substring = expected.matchSubstring ? this.normalizeWhiteSpace(expected.string) : undefined;\n    this._regex = expected.regexSource ? new RegExp(expected.regexSource, expected.regexFlags) : undefined;\n  }\n\n  matches(text) {\n    if (this._normalizeWhiteSpace && !this._regex) text = this.normalizeWhiteSpace(text);\n    if (this._string !== undefined) return text === this._string;\n    if (this._substring !== undefined) return text.includes(this._substring);\n    if (this._regex) return !!this._regex.test(text);\n    return false;\n  }\n\n  normalizeWhiteSpace(s) {\n    if (!s) return s;\n    return this._normalizeWhiteSpace ? s.trim().replace(/\\s+/g, ' ') : s;\n  }\n\n}\n\nfunction deepEquals(a, b) {\n  if (a === b) return true;\n\n  if (a && b && typeof a === 'object' && typeof b === 'object') {\n    if (a.constructor !== b.constructor) return false;\n\n    if (Array.isArray(a)) {\n      if (a.length !== b.length) return false;\n\n      for (let i = 0; i < a.length; ++i) {\n        if (!deepEquals(a[i], b[i])) return false;\n      }\n\n      return true;\n    }\n\n    if (a instanceof RegExp) return a.source === b.source && a.flags === b.flags; // This covers Date.\n\n    if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf(); // This covers custom objects.\n\n    if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();\n    const keys = Object.keys(a);\n    if (keys.length !== Object.keys(b).length) return false;\n\n    for (let i = 0; i < keys.length; ++i) {\n      if (!b.hasOwnProperty(keys[i])) return false;\n    }\n\n    for (const key of keys) {\n      if (!deepEquals(a[key], b[key])) return false;\n    }\n\n    return true;\n  }\n\n  if (typeof a === 'number' && typeof b === 'number') return isNaN(a) && isNaN(b);\n  return false;\n}\n\nfunction isElementDisabled(element) {\n  const isRealFormControl = ['BUTTON', 'INPUT', 'SELECT', 'TEXTAREA'].includes(element.nodeName);\n  if (isRealFormControl && element.hasAttribute('disabled')) return true;\n  if (isRealFormControl && hasDisabledFieldSet(element)) return true;\n  if (hasAriaDisabled(element)) return true;\n  return false;\n}\n\nfunction hasDisabledFieldSet(element) {\n  if (!element) return false;\n  if (element.tagName === 'FIELDSET' && element.hasAttribute('disabled')) return true; // fieldset does not work across shadow boundaries\n\n  return hasDisabledFieldSet(element.parentElement);\n}\n\nfunction hasAriaDisabled(element) {\n  if (!element) return false;\n  const attribute = (element.getAttribute('aria-disabled') || '').toLowerCase();\n  if (attribute === 'true') return true;\n  if (attribute === 'false') return false;\n  return hasAriaDisabled((0, _selectorEvaluator.parentElementOrShadowHost)(element));\n}\n\nvar _default = InjectedScript;\nexports[\"default\"] = _default;\n})();\n\npwExport = __webpack_exports__[\"default\"];\n/******/ })()\n;";
exports.source = source;
//# sourceMappingURL=injectedScriptSource.js.map